jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.stress.config.model.Hierarchy");
jQuery.sap.require("sas.stress.config.model.HierarchyMapPair");
jQuery.sap.require("sas.stress.pfd.PfdStyles");
jQuery.sap.require("sas.stress.wkbench.CapabilityManager");
jQuery.sap.require("sas.stress.wkbench.EventBusConstants");
jQuery.sap.require("sas.stress.wkbench.LeftNavManager");
jQuery.sap.require("sas.stress.wkbench.StressGoTemplates");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.ViewManager");
jQuery.sap.require("sas.stress.wkbench.widget.ProcessDiagram");

jQuery.sap.require("sap.ui.core.Control");
jQuery.sap.require("sas.hc.graph.GraphView");
jQuery.sap.require("sas.hc.graph.UIView");
jQuery.sap.require("sas.hc.m.MessageDialog");
jQuery.sap.require("sas.hc.ui.unified.Menu");
jQuery.sap.require("sas.ltjs.commons.gestures.GestureHelper");
jQuery.sap.require("sas.ltjs.gtl.models.data.DataSetDataProvider");
jQuery.sap.require("sas.ltjs.gtl.models.Graph");
jQuery.sap.require("sas.ltjs.gtl.models.layoutRegion.LayoutRegion");
jQuery.sap.require("sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDModel");
jQuery.sap.require("sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDArrangementEnum");
jQuery.sap.require("sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDToolbarIconEnum");
jQuery.sap.require("sas.ltjs.gtl.models.data.Role");
jQuery.sap.require("sas.ltjs.gtl.models.data.PlotRole");
jQuery.sap.require("sas.ltjs.gtl.models.core.RelativeDirection");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.Column");
jQuery.sap.require("sas.ltjs.gtl.models.data.ClassificationRole");
jQuery.sap.require("sas.ltjs.gtl.models.core.ColorModel");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataSet");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataType");
jQuery.sap.require("sas.ltjs.commons.models.data.DataValue");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.MutableColumn");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.MutableDataSet");
jQuery.sap.require("sas.ltjs.gtl.models.data.MutableDataSetDataProvider");
//jQuery.sap.require("sas.ltjs.commons.models.data.dataset.MutableDataSetChangeEvent");
jQuery.sap.require("sas.ltjs.ltjsLoader");


sap.ui.controller("sas.stress.config.view.Configuration", {

    rb: sap.ui.getCore().getLibraryResourceBundle("sas.stress.wkbench"),

    onInit: function () {
        this.router = sap.ui.core.routing.Router.getRouter("router");
        this.router.attachExactRouteMatched("Configuration", this._init, this);

    },

    _init: function (event) {

        // show groove bar
        sas.stress.wkbench.LeftNavManager.getInstance().showGrooveBar(sas.stress.wkbench.LeftNavManager.CONFIGURATION);

        // Defect S1312016: each modifiable view, such as CreateWorksheetTemplateEditor and HierarchyMapping has its own navChecker to handle dirty state.
        // no need to have navChecker for the top Configuration view.  It causes problems as in defect S1312016
        //this.navChecker = sas.stress.wkbench.StressUtil.createNavChecker(true);  // NavChecker should not destroy this view

        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_CONFIG_ROOT, this.updateViews, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_HIERARCHIES, this.viewHierarchies, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_HIERARCHY_MAPPING, this.editHierarchyMapping, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_WORKSHEET_TEMPLATES, this.viewWorksheetTemplates, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_WORKSHEET_TEMPLATE, this.createWorksheetTemplate, this);
        // sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_DATA_CROSSING, this.createDataCrossing, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_MODELS, this.viewModels, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_MODEL_DETAILS, this.viewModelDetails, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_ARCHIVES, this.viewArchives, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.CREATE_ARCHIVE, this.createArchive, this);
        //sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_MODEL_GROUP, this.createModelGroupView, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_SLAM_CONFIG_MGR, this.viewSlamConfigurationMgr, this);
        sas.eventBus.subscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_SLAM_CONFIGURATION, this.createSlamConfiguration, this);
    },

    //S1317422: don't add view till tab is selected to avoid FocusHandler loop in IE.
    //onAfterRendering: function () {
    //    var view = this.getView();
    //    //Putting in timeout seems to improve performance
    //    setTimeout(function () {
    //        view.createTabViews();
    //    }, 0);
    //},

    createWorksheetTemplate: function (channel, event, data) {
        var selectedCategoryKey = data.selectedCategoryKey;
        var template = data.template;
        var view = this.getView();
        var createWorksheetArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: sas.stress.wkbench.ViewManager.loadCreateWorksheetTemplateEditor({
                    template: template,
                    selectedCategoryKey: selectedCategoryKey
                }
            )
        });
        view.worksheetLayout.setCenter(createWorksheetArea);
    },

    createDataCrossing: function (channel, event, data) {
        var selectedCategoryKey = data.selectedCategoryKey;
        var template = data.template;
        var view = this.getView();
        var createDataCrossingArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: sas.stress.wkbench.ViewManager.loadCreateDataCrossing({
                    template: template,
                    selectedCategoryKey: selectedCategoryKey
                }
            )
        });
        view.worksheetLayout.setCenter(createDataCrossingArea);
    },


    viewWorksheetTemplates: function (channel, event, data) {
        var view = this.getView();
        if (view.worksheetLayout.getCenter() !== view.worksheetArea) {
            // in case the sub view is not destroyed
            view.worksheetLayout.getCenter().destroy();
            view.worksheetLayout.setCenter(view.worksheetArea);
        }
    },

    viewHierarchies: function (channel, event, data) {
        var view = this.getView();
        if (view.hierarchyLayout.getCenter() !== view.hierarchyArea) {
            // in case the sub view is not destroyed
            view.hierarchyLayout.getCenter().destroy();
            view.hierarchyLayout.setCenter(view.hierarchyArea);
        }//else{
        //    if (view.mapGraphLayout.getCenter() &&
        //        view.mapGraphLayout.getCenter() !== view.mapGraphArea) {
        //        view.mapGraphLayout.getCenter().destroy();
        //        view.mapGraphLayout.setCenter(view.mapGraphArea);
        //    }
        //}
    },

    editHierarchyMapping: function (channel, event, data) {
        var hierarchyKey = data.hierarchyKey;
        var view = this.getView();
        var hierarchyArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: sas.stress.wkbench.ViewManager.loadHierarchyMappingEditor({ hierarchyKey: hierarchyKey })
        });
        view.hierarchyLayout.setCenter(hierarchyArea);
    },

    viewModels: function (channel, event, data) {
        var view = this.getView();
        if (view.modelLayout.getCenter() !== view.modelArea) {
            // in case the sub view is not destroyed
            view.modelLayout.getCenter().destroy();
            view.modelLayout.setCenter(view.modelArea);
        }
    },

    viewModelDetails: function (channel, event, data) {
        var model = data.model;
        var view = this.getView();
        var modelArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: sas.stress.wkbench.ViewManager.loadModelsDetails({ modelId: model.id })
        });
        view.modelLayout.setCenter(modelArea);
    },

    viewModelGroups: function (channel, event, data) {
        var view = this.getView();
        if (view.modelGroupLayout.getCenter() !== view.modelGroupArea) {
            // in case the sub view is not destroyed
            view.modelGroupLayout.getCenter().destroy();
            view.modelGroupLayout.setCenter(view.modelGroupArea);
        }
    },

    viewArchives: function (channel, event, data) {
        var view = this.getView();
        if (view.archiveLayout.getCenter() !== view.archiveArea) {
            // in case the sub view is not destroyed
            view.archiveLayout.getCenter().destroy();
            view.archiveLayout.setCenter(view.archiveArea);
        }
    },
    createArchive: function (channel, event, data) {
        var view = this.getView();
        var createArchiveArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: sas.stress.wkbench.ViewManager.loadCreateArchive()
        });
        view.archiveLayout.setCenter(createArchiveArea);
    },

    viewSlamConfigurationMgr: function (channel, event, data) {
        var view = this.getView();
        if (view.subledgerManagerLayout.getCenter() !== view.subledgerManagerArea) {
            // in case the sub view is not destroyed
            view.subledgerManagerLayout.getCenter().destroy();
            view.subledgerManagerLayout.setCenter(view.subledgerManagerArea);
        }
    },

    createSlamConfiguration: function (channel, event, data) {
        var view = this.getView();
        var createSubledgerArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: sas.stress.wkbench.ViewManager.loadCreateSlamConfiguration({name: data.name, domainId: data.domainId, subledgerName: data.subledgerName, subledgerId: data.subledgerId, subledgerVersion: data.subledgerVersion, editSubledger: data.editSubledger})
        });
        view.subledgerManagerLayout.setCenter(createSubledgerArea);
    },

    // TODO: remove deprecated code  (JSZ)
    // createModelGroupView: function (channel, event, data) {
    //    var template = data.template;
    //    var view = this.getView();
    //    var createModelGroupArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
    //        content: sas.stress.wkbench.ViewManager.loadCreateModelGroupEditor({ template: template })
    //    });
    //    view.modelGroupLayout.setCenter(createModelGroupArea);
    //},

    onExit: function () {
        // Remove any subscriptions to ensure we don't get duplicates the next time the controller is initialized
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_CONFIG_ROOT, this.updateViews, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_HIERARCHIES, this.viewHierarchies, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_HIERARCHY_MAPPING, this.editHierarchyMapping, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_WORKSHEET_TEMPLATES, this.viewWorksheetTemplates, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_WORKSHEET_TEMPLATE, this.createWorksheetTemplate, this);
        // sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_DATA_CROSSING, this.createDataCrossing, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_MODELS, this.viewModels, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_MODEL_DETAILS, this.viewModelDetails, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_ARCHIVES, this.viewArchives, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.CREATE_ARCHIVE, this.createArchive, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_SLAM_CONFIG_MGR, this.viewSlamConfigurationMgr, this);
        sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_SLAM_CONFIGURATION, this.createSlamConfiguration, this);
      //  sas.eventBus.unsubscribe(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.EDIT_MODEL_GROUP, this.createModelGroupView, this);
        this.router.detachExactRouteMatched("Configuration", this._init, this);
        // clear the View on the router otherwise the next router.navTo() would fail with a blank page
        this.router.setView("sas.stress.config.view.Configuration", null);
        //this.navChecker.stop();    // Defect S1312016
    },

    updateViews: function (event) {

        var view = this.getView();
        var that = this;

        if (view.hierarchyLayout.getCenter() &&
            view.hierarchyLayout.getCenter() !== view.hierarchyArea) {
            view.hierarchyLayout.getCenter().destroy();
            view.hierarchyLayout.setCenter(view.hierarchyArea);
        }
        if (view.worksheetLayout.getCenter() &&
            view.worksheetLayout.getCenter() !== view.worksheetArea) {
            view.worksheetLayout.getCenter().destroy();
            view.worksheetLayout.setCenter(view.worksheetArea);
        }
        //if (view.modelLayout.getCenter() &&
        //    view.modelLayout.getCenter() !== view.modelArea) {
        //    view.modelLayout.getCenter().destroy();
        //    view.modelLayout.setCenter(view.modelArea);
        //}
        if (view.mapGraphLayout.getCenter() &&
            view.mapGraphLayout.getCenter() !== view.mapGraphArea) {
            view.mapGraphLayout.getCenter().destroy();
            view.mapGraphLayout.setCenter(view.mapGraphArea);
        }
        if (view.archiveLayout.getCenter() &&
            view.archiveLayout.getCenter() !== view.archiveArea) {
            view.archiveLayout.getCenter().destroy();
            view.archiveLayout.setCenter(view.archiveArea);
        }
        if (view.subledgerManagerLayout.getCenter() &&
            view.subledgerManagerLayout.getCenter() !== view.subledgerManagerArea) {
            view.subledgerManagerLayout.getCenter().destroy();
            view.subledgerManagerLayout.setCenter(view.subledgerManagerArea);
        }

        if (typeof event === 'object' &&
            event.getParameter("tab") &&
            event.getParameter("tab").getId() === "mapGraphLayout") {
            this._getHierarchyMapPairs().done(function (hierarchyMapPairs) {
                // We build the graph every time this tab is selected because user
                // could have made changes in the previous tab that affects the graph.
                that._buildHierarchyMapPairsGraph(hierarchyMapPairs);
            });
        }
    },

    _getHierarchyMapPairs: function () {
        var deferred = $.Deferred();
        sas.stress.config.model.HierarchyMapPair.getHierarchyMapPairs().done(function (hierarchyMapPairs) {
            deferred.resolve(hierarchyMapPairs);
        }).fail(function () {
            var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
            sas.hc.m.MessageDialog.error({text: rb.getText('error.message.txt'), title: rb.getText('error.window.title')});
            deferred.reject();
        });
        return deferred;
    },


    createAndPlaceGraph: function (graphView, mapGraphArea, nodeDataArray, linkDataArray) {
        var DataType = sas.ltjs.commons.models.data.dataset.DataType,
            DataValue = sas.ltjs.commons.models.data.DataValue,
            MutableDataSetDataProvider = sas.ltjs.gtl.models.data.MutableDataSetDataProvider,

            PFDModel = sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDModel,
            PFDArrangementEnum = sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDArrangementEnum,
            Graph = sas.ltjs.gtl.models.Graph,
            LayoutRegion = sas.ltjs.gtl.models.layoutRegion.LayoutRegion,
            PlotRole = sas.ltjs.gtl.models.data.PlotRole,
            MutableColumn = sas.ltjs.commons.models.data.dataset.MutableColumn,
            MutableDataSetChangeEvent = sas.ltjs.commons.models.data.dataset.MutableDataSetChangeEvent,
            ClassificationRole = sas.ltjs.gtl.models.data.ClassificationRole,
            DataSet = sas.ltjs.commons.models.data.dataset.DataSet,
            RelativeDirection = sas.ltjs.gtl.models.core.RelativeDirection,
            Menu = sas.hc.ui.commons.Menu,
            GestureHelper = sas.ltjs.commons.gestures.GestureHelper,
            ColorModel = sas.ltjs.gtl.models.core.ColorModel,
            MutableDataSet = sas.ltjs.commons.models.data.dataset.MutableDataSet;
            PFDToolbarIconEnum=sas.ltjs.gtl.models.layoutRegion.nodeLinkDiagram.processFlowDiagram.PFDToolbarIconEnum;

        var graph = new Graph(),
            layout = (new LayoutRegion()).retain(),
            pfd = new PFDModel();
            dataSet = new MutableDataSet(true);


        var nodeIdArray = [];
        var nodeTypeArray = [];
        var nodeTitleArray = [];
        var fromColumnArray = [];
        var toColumnArray = [];
        var noOfNodes = nodeDataArray.length;
        var noOfLinks = linkDataArray.length;

        for ( var i = 0; i < noOfNodes; i++) {
            nodeIdArray.push(new DataValue("node"+nodeDataArray[i].key, 0));
            nodeTypeArray.push(new DataValue("NODE",0));
            nodeTitleArray.push(new DataValue(nodeDataArray[i].text,0));
            fromColumnArray.push(null);
            toColumnArray.push(null);
        }
        for ( i = 0; i < noOfLinks; i++) {
            nodeIdArray.push(new DataValue("link"+nodeDataArray[i].key, 0));
            nodeTypeArray.push(new DataValue("LINK",0));
            nodeTitleArray.push(null);
        }
        for ( i = 0; i < linkDataArray.length; i++) {
            fromColumnArray.push(new DataValue("node"+linkDataArray[i].from, 0));
            toColumnArray.push(new DataValue("node"+linkDataArray[i].to, 0));
        }

        var nodeIdColumn = new MutableColumn("id", null, DataType.STRING);
        dataSet.appendColumn(nodeIdColumn,nodeIdArray);

        var nodeTypeColumn = new MutableColumn("type", null, DataType.STRING);
        dataSet.appendColumn(nodeTypeColumn,nodeTypeArray);

        var titleColumn = new MutableColumn("title", null, DataType.STRING);
        dataSet.appendColumn(titleColumn,nodeTitleArray);

        var fromColumn = new MutableColumn("fromNode", null, DataType.STRING);
        dataSet.appendColumn(fromColumn,fromColumnArray);

        var toColumn = new MutableColumn("toNode", null, DataType.STRING);
        dataSet.appendColumn(toColumn,toColumnArray);

        pfd.setNodeId(new ClassificationRole("id"));
        pfd.setLinkId(new ClassificationRole("id"));
        pfd.setType(new ClassificationRole("type"));
        pfd.setFromId(new ClassificationRole("fromNode"));
        pfd.setToId(new ClassificationRole("toNode"));
        pfd.setNodeTip([new ClassificationRole("title")]);
        pfd.setNodeTitle(new PlotRole("title"));
        pfd.setArrangement(PFDArrangementEnum.LAYERED);
        pfd.setToolbarIcon(PFDToolbarIconEnum.NONE);

        var layeredOpts = pfd.getLayeredOpts();
        layeredOpts.setOrientation(RelativeDirection.RIGHT);

        graphView.setGraph(graph);
        layout.setRegion(pfd);
        graph.setLayout(layout);

        layout.setDataProvider(new MutableDataSetDataProvider(dataSet));

        var oMenu = new Menu();

        var d = dataSet.retain();
        var pfdIndex;

        var createMenuItem = function(_oMenu, sText, sFunction) {
            var item = new sas.hc.ui.unified.MenuItem({
                text: sText
            });

            item.attachSelect(sFunction);

            oMenu.addItem(item);
            return item;
        };

        var fnCustomizeContextMenu = function(oMenu, oEvent) {
            oMenu.removeAllItems(); //remove any old items

            var element = document.getElementById(this.getId());
            var mouse = GestureHelper.getMousePosition(oEvent, element);
            var x = mouse.localX;
            var y = mouse.localY;
            var pick = graphView.getPickResults(x, y, false);

            if (pick[0]){
                var entries = pick[0].getEntries();
                if (entries) {
                    var entry = entries[0];
                    if (entry) {
                        pfdIndex = entry.getIndices()[0];
                        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
                        createMenuItem(oMenu, rb.getText('hierarchiesTreeTable.editButton.tip'), openHierarchyNode);
                        return oMenu;
                    }
                }
            }
        };

        var openHierarchyNode = function() {

            var fromVals = d.getColumnDataValues(d.getColumnIndexByName("fromNode"));
            var toVals = d.getColumnDataValues(d.getColumnIndexByName("toNode"));
            var idVals = d.getColumnDataValues(d.getColumnIndexByName("id"));
            var nodeRemove = idVals[pfdIndex].getStringValue();

            var capabilityManager = sas.stress.wkbench.CapabilityManager.getInstance();
            if (capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.HIERARCHY.UPDATE)) {
                var hierarchyKey = nodeRemove.substring(4); // nodeRemove will have values like node3003 so we need only the 3003, strip off node
                if (hierarchyKey) {
                    //Need to differentiate between invoked from edit Hierarchies page or Edit Hierarchy Map page
                    // the flag sets the two entry points apart
                    var hierarchyArea = new sas.hc.ui.commons.layout.BorderLayoutArea({ content: sas.stress.wkbench.ViewManager.loadHierarchyMappingEditor({ hierarchyKey: parseInt(hierarchyKey), fromGraphLayout: true }) });
                    var view = sas.stress.wkbench.ViewManager.getConfiguration();
                    view.mapGraphLayout.setCenter(hierarchyArea);
                }
            }
        };

        graphView.setAggregation("contextMenu", oMenu);
        graphView.customizeContextMenu = fnCustomizeContextMenu;

        graphView.placeAt(mapGraphArea);
    },

    _buildHierarchyMapPairsGraph: function (hierarchyMapPairs) {
        var controller = this;
        var nodeDataArray = [];
        var pfdStyles = sas.stress.pfd.PfdStyles.init();
        var view = this.getView();


        var graphView = new sas.hc.graph.GraphView({height:'100%', width:'100%'});

        view.mapGraphArea.removeAllContent();

        _.each(sas.stress.config.model.Hierarchy.getCachedHierarchies(), function (hierarchy) {
            nodeDataArray.push(
                {
                    key: hierarchy.getHierarchyKey(),
                    text: sas.stress.wkbench.StressUtil.getNameVersion(hierarchy.getName(),hierarchy.getVersion()), // fixes for S1312588
                    fill: pfdStyles.hierarchySimpleNodeFillColor,
                    stroke: pfdStyles.hierarchySimpleNodeStrokeColor,
                    color: pfdStyles.hierarchySimpleNodeTextColor,
                    tooltip: sas.stress.wkbench.StressUtil.getNameVersion(hierarchy.getName(),hierarchy.getVersion())
                }
            );
        });

        if (nodeDataArray.length === 0 ) {
            sas.stress.config.model.Hierarchy.getHierarchies().done(function (hierarchies) {
                _.each(hierarchies, function (hierarchy) {
                    nodeDataArray.push(
                        {
                            key: hierarchy.getHierarchyKey(),
                            text: sas.stress.wkbench.StressUtil.getNameVersion(hierarchy.getName(), hierarchy.getVersion()), // fixes for S1312588
                            fill: pfdStyles.hierarchySimpleNodeFillColor,
                            stroke: pfdStyles.hierarchySimpleNodeStrokeColor,
                            color: pfdStyles.hierarchySimpleNodeTextColor,
                            tooltip: sas.stress.wkbench.StressUtil.getNameVersion(hierarchy.getName(),hierarchy.getVersion())
                        }
                    );
                });

                var linkDataArray = [];
                _.each(hierarchyMapPairs, function (hierarchyMapPair) {
                    linkDataArray.push({ from: hierarchyMapPair.getFromHierKey(), to: hierarchyMapPair.getToHierKey() });
                });

                controller.createAndPlaceGraph(graphView, view.mapGraphArea, nodeDataArray, linkDataArray );


            }).fail(function(jqxhr) {
                sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
            });
        } else {
            var linkDataArray = [];
            _.each(hierarchyMapPairs, function (hierarchyMapPair) {
                linkDataArray.push({ from: hierarchyMapPair.getFromHierKey(), to: hierarchyMapPair.getToHierKey() });
            });

            controller.createAndPlaceGraph(graphView, view.mapGraphArea, nodeDataArray, linkDataArray );
        }
    },
});