jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
jQuery.sap.require("sas.hc.ui.commons.verticalTab.VerticalTab");
jQuery.sap.require("sas.hc.ui.commons.verticalTab.VerticalTabBar");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.m.Label");
jQuery.sap.require("sas.risk.common.widgets.RiskToolbar");
jQuery.sap.require("sas.risk.common.widgets.RiskPage");
jQuery.sap.require("sas.risk.common.widgets.WidgetFactory");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.ViewManager");

sap.ui.jsview("sas.stress.config.view.Configuration", {

    getControllerName: function () {
        return "sas.stress.config.view.Configuration";
    },

    createContent: function (controller) {
        this.setHeight("100%");

        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.wkbench");

        this.hierarchyLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.hierarchyArea = new sas.hc.ui.commons.layout.BorderLayoutArea(); //{ content: hierarchyView });
        this.hierarchyLayout.setCenter(this.hierarchyArea);

        this.mapGraphLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.mapGraphToolbar = new sas.hc.ui.commons.layout.BorderLayoutArea({ size: "2.5rem" });
        this.mapGraphArea = new sas.hc.ui.commons.layout.BorderLayoutArea();
        this.mapGraphLayout.setTop(this.mapGraphToolbar);
        this.mapGraphLayout.setCenter(this.mapGraphArea);

        this.processLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.processArea = new sas.hc.ui.commons.layout.BorderLayoutArea(); //{ content: sas.stress.wkbench.ViewManager.loadProcessDefinitions() });
        this.processLayout.setCenter(this.processArea);

        this.worksheetLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.worksheetArea = new sas.hc.ui.commons.layout.BorderLayoutArea(); //{ content: worksheetView });
        this.worksheetLayout.setCenter(this.worksheetArea);

        this.archiveLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.archiveArea = new sas.hc.ui.commons.layout.BorderLayoutArea();
        this.archiveLayout.setCenter(this.archiveArea);

        this.crossingLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.crossingArea = new sas.hc.ui.commons.layout.BorderLayoutArea();
        this.crossingLayout.setCenter(this.crossingArea);

        this.dimensionLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.dimensionArea = new sas.hc.ui.commons.layout.BorderLayoutArea();
        this.dimensionLayout.setCenter(this.dimensionArea);

        this.userLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.userArea = new sas.hc.ui.commons.layout.BorderLayoutArea();
        this.userLayout.setCenter(this.userArea);

        this.subledgerManagerLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        this.subledgerManagerArea = new sas.hc.ui.commons.layout.BorderLayoutArea();
        this.subledgerManagerLayout.setCenter(this.subledgerManagerArea);


        var tabPanel = new sas.hc.ui.commons.verticalTab.VerticalTabBar({
            height: "100%",
            tabSelect: $.proxy(controller.updateViews, controller),
            tabs: [
                new sas.hc.ui.commons.verticalTab.VerticalTab({
                    id: "dimensionLayout",
                    title: rb.getText("home.shortcut.dimensions.txt"),
                    icon: sas.icons.HC.DIMENSIONS,
                    content: [this.dimensionLayout]
                }),
                new sas.hc.ui.commons.verticalTab.VerticalTab({
                    id: "hierarchyLayout",
                    title: rb.getText("home.shortcut.hierarchies.txt"),
                    icon: sas.icons.HC.HIERARCHYVIEW,
                    content: [this.hierarchyLayout]
                }),
                //Todo may remove View code in the future release
                // new sas.hc.ui.commons.verticalTab.VerticalTab({
                //     id: "mapGraphLayout",
                //     title: rb.getText("home.shortcut.hierarchymap.txt"),
                //     icon: sas.icons.HC.PFDMODEL,
                //     content: [sas.risk.common.widgets.WidgetFactory.buildPanel({content: this.mapGraphLayout.addStyleClass("riskObject")})]
                // }),
                new sas.hc.ui.commons.verticalTab.VerticalTab({
                    id: "worksheetLayout",
                    title: rb.getText("home.shortcut.worksheets.txt"),
                    icon: sas.icons.HC.PHYSICALTABLE,
                    content: [this.worksheetLayout]
                }),
                new sas.hc.ui.commons.verticalTab.VerticalTab({
                    id: "processLayout",
                    title: rb.getText("home.shortcut.process.txt"),
                    icon: sas.icons.HC.DECISIONTREE,
                    content: [this.processLayout]
                }),
                new sas.hc.ui.commons.verticalTab.VerticalTab({
                    id: "archiveLayout",
                    title: rb.getText("home.shortcut.archives.txt"),
                    icon: sas.icons.HC.ARCHIVES,
                    content: [this.archiveLayout]
                }),
                new sas.hc.ui.commons.verticalTab.VerticalTab({
                    id: "userLayout",
                    title: rb.getText("home.shortcut.users.txt"),
                    icon: sas.icons.HC.USERSROLE,
                    content: [this.userLayout]
                }),
                //new sas.hc.ui.commons.verticalTab.VerticalTab({
                //    id: "crossingLayout",
                //    title: rb.getText("home.shortcut.crossings.txt"),
                //    icon: sas.icons.HC.ARCHIVES,  //@@ DD: needs new icon
                //    content: [this.crossingLayout]
                //}),
                // To disable SLAM comment out below:
//                new sas.hc.ui.commons.verticalTab.VerticalTab({
//                    id: "subledgerManagerLayout",
//                    title: rb.getText("home.shortcut.slam.txt"),
//                    icon: sas.icons.HC.SASNOTEBOOK,
//                    content: [this.subledgerManagerLayout]
//                }),
            ]
        }).addStyleClass("stressConfigTabPanel");

        var view = this;
        tabPanel.setSelectedTab = function (value) {
            var createWorksheet = sas.stress.wkbench.ViewManager.getCreateWorksheetTemplateEditor();
            var createHierarchy = sas.stress.wkbench.ViewManager.getHierarchyMapping();
            var createArchive   = sas.stress.wkbench.ViewManager.getCreateArchive();
            var createDataCrossing   = sas.stress.wkbench.ViewManager.getCreateDataCrossingEditor();
            var createDimension   = sas.stress.wkbench.ViewManager.getCreateDimensionEditor();
            var createSubledger = sas.stress.wkbench.ViewManager.getCreateSubledgerAccounting();

            var createWorksheetNavChecker = false;
            if (createWorksheet !== undefined) {
                createWorksheetNavChecker = createWorksheet.getController().navChecker.getDirty();
            }

            var createHierarchyNavChecker = false;
            if (createHierarchy !== undefined) {
                createHierarchyNavChecker = createHierarchy.getController().navChecker.getDirty();
            }

            var createArchiveNavChecker = false;
            if (createArchive !== undefined) {
                createArchiveNavChecker = createArchive.getController().navChecker.getDirty();
            }

            var createDataCrossingNavChecker = false;
            if (createDataCrossing !== undefined) {
                createDataCrossingNavChecker = createDataCrossing.getController().navChecker.getDirty();
            }

            var createDimensionNavChecker = false;
            if (createDimension !== undefined) {
                createDimensionNavChecker = createDimension.getController().navChecker.getDirty();
            }

            var createSubledgerNavChecker = false;
            if (createSubledger !== undefined) {
                createSubledgerNavChecker = createSubledger.getController().navChecker.getDirty();
            }

            var isDirty = createWorksheetNavChecker || createHierarchyNavChecker || createArchiveNavChecker || createDataCrossingNavChecker || createDimensionNavChecker || createSubledgerNavChecker;

            if (sas.stress.wkbench.StressUtil.confirmToContinue(isDirty) ) {
                //S1317422: add and show only the selected view to avoid FocusHandler loop in IE.
                view.showTabView(value);
                sas.hc.ui.commons.verticalTab.VerticalTabBar.prototype.setSelectedTab.apply(this, arguments);
            }

        };

        this.viewLayout = new sas.risk.common.widgets.RiskPage({
            mainContent: tabPanel,
            toolbar: new sas.risk.common.widgets.RiskToolbar({
                title: new sas.hc.m.Label({ text: rb.getText("home.shortcut.configuration.txt") })
            })
        });

        return this.viewLayout;
    },

    createTabViews: function() {

        if (this.hierarchyArea.getContent().length === 0) {
            this.hierarchyArea.addContent(sas.stress.wkbench.ViewManager.loadProjectConfiguration());
        }
        if (this.worksheetArea.getContent().length === 0) {
            this.worksheetArea.addContent(sas.stress.wkbench.ViewManager.loadSheetTemplateManager());
        }
        if (this.processArea.getContent().length === 0) {
            this.processArea.addContent(sas.stress.wkbench.ViewManager.loadProcessDefinitions());
        }
        if (this.crossingArea.getContent().length === 0) {
            this.crossingArea.addContent(sas.stress.wkbench.ViewManager.loadDataCrossingsManager());
        }
        if (this.dimensionArea.getContent().length === 0) {
            this.dimensionArea.addContent(sas.stress.wkbench.ViewManager.loadDimensionManager());
        }
        if (this.userArea.getContent().length === 0) {
            this.userArea.addContent(sas.stress.wkbench.ViewManager.loadUserManager());
        }
        if (this.subledgerArea.getContent().length === 0) {
            this.subledgerArea.addContent(sas.stress.wkbench.ViewManager.loadSubledgerAccountingView());
        }
        if (this.subledgerManagerArea.getContent().length === 0) {
            this.subledgerManagerArea.addContent(sas.stress.wkbench.ViewManager.loadSubledgerAccountingManagerView());
        }
    },

    //Show one view at a time based on tab selection to avoid FocusHandler loop in IE.
    showTabView: function(tab) {
        if (tab && tab instanceof sas.hc.ui.commons.verticalTab.VerticalTab) {
            var tabId = tab.getId();
            if (tabId === "hierarchyLayout") {
                if (this.hierarchyArea.getContent().length === 0) {
                    this.hierarchyArea.addContent(sas.stress.wkbench.ViewManager.loadProjectConfiguration());
                }
            } else {
                this.hierarchyArea.removeAllContent();
            }
            if (tabId === "worksheetLayout") {
                if (this.worksheetArea.getContent().length === 0) {
                    this.worksheetArea.addContent(sas.stress.wkbench.ViewManager.loadSheetTemplateManager());
                }
            } else {
                this.worksheetArea.removeAllContent();
            }
            if (tabId === "processLayout") {
                if (this.processArea.getContent().length === 0) {
                    this.processArea.addContent(sas.stress.wkbench.ViewManager.loadProcessDefinitions());
                }
            } else {
                this.processArea.removeAllContent();
            }
            if (tabId === "archiveLayout") {
                if (this.archiveArea.getContent().length === 0) {
                    this.archiveArea.addContent(sas.stress.wkbench.ViewManager.loadArchiveManager());
                }
            } else {
                this.archiveArea.removeAllContent();
            }

            if (tabId === "crossingLayout") {
                if (this.crossingArea.getContent().length === 0) {
                    this.crossingArea.addContent(sas.stress.wkbench.ViewManager.loadDataCrossingManager());
                }
            } else {
                this.crossingArea.removeAllContent();
            }

            if (tabId === "dimensionLayout") {
                if (this.dimensionArea.getContent().length === 0) {
                    this.dimensionArea.addContent(sas.stress.wkbench.ViewManager.loadDimensionManager());
                }
            } else {
                this.dimensionArea.removeAllContent();
            }

            if (tabId === "userLayout") {
                if (this.userArea.getContent().length === 0) {
                    this.userArea.addContent(sas.stress.wkbench.ViewManager.loadUserManager());
                }
            } else {
                this.userArea.removeAllContent();
            }

            if (tabId === "subledgerManagerLayout") {
                if (this.subledgerManagerArea.getContent().length === 0) {
                    this.subledgerManagerArea.addContent(sas.stress.wkbench.ViewManager.loadSubledgerAccountingManagerView());
                }
            } else {
                this.subledgerManagerArea.removeAllContent();
            }
        }
    }
    //destroy: function () {
    //    sap.ui.core.mvc.JSView.prototype.destroy.apply(this, arguments);
    //}
});