jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.m.CheckBox");
jQuery.sap.require("sas.hc.m.Dialog");
jQuery.sap.require("sas.hc.m.Input");
jQuery.sap.require("sas.hc.m.Label");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.ui.layout.HorizontalLayout");
jQuery.sap.require("sas.hc.ui.layout.VerticalLayout");
jQuery.sap.require("sas.hc.ui.table.TreeTable");
jQuery.sap.require("sas.hc.ui.table.Column");

sap.ui.jsfragment("sas.stress.config.view.CreateSubledgerAccountingDialog", {
    createContent: function (controller) {
        //var view = this.getView();
        // var memberList = this.getModel().getData().selectedMemberList;
        var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");

        var domainTemplate = new sap.ui.core.Item({
            text: "{name}",
            tooltip: "{name}",
            key: "{key}"
        });

        this.domainSelectLabel = new sas.hc.m.Label({
            text: rb.getText("subledgerAccountingManagerDialog.domainSelect.label")
        });
        this.domainSelect = new sas.hc.m.Select({
         id: "subledgerDialog.domainSelect",
          change: function(oEvent) {
             var item = oEvent.getParameter('selectedItem');
             var index = this.indexOfItem(item);
             var bindingIndex = "/domains/" + index + "/subledgers";

             var subledgerTemplate = new sap.ui.core.Item({
                  text: {
                      parts: ["name","version"],
                      formatter: function (name, version) {
                          return name + " - " + version;
                      }
                  },
                  tooltip: "{name}",
                  key: "{key}"
             });
             var subledgerSelect = sap.ui.getCore().byId("subledgerDialog.subledgerSelect") ;
             subledgerSelect.bindItems(bindingIndex, subledgerTemplate, null);
             var createButton = sap.ui.getCore().byId("subledgerAccountingManagerDialog.createButton");

             if (sap.ui.getCore().byId("subledgerDialog.subledgerSelect").getSelectedItem() == null) {
                  createButton.setEnabled(false);
             } else {
                 createButton.setEnabled(true);
             }
             //$.proxy(controller.loadSubledgersOnly(oEvent.getParameter('selectedItem').getKey()), controller);
          }
        });

        this.domainSelect.bindItems("/domains", domainTemplate, null);

        var subledgerTemplate = new sap.ui.core.Item({
            text: {
                parts: ["name","version"],
                formatter: function (name, version) {
                    return name + " - " + version;
                }
            },
            tooltip: "{name}",
            key: "{key}"
        });

        this.subledgerSelectLabel = new sas.hc.m.Label({
            text: rb.getText("subledgerAccountingManagerDialog.subledgerSelect.label")
        });
        this.subledgerSelect = new sas.hc.m.Select({
            id: "subledgerDialog.subledgerSelect",
            change: function(oEvent) {
                $.proxy(controller.loadSubledgerData(
                    sap.ui.getCore().byId("subledgerDialog.domainSelect").getSelectedKey(),
                    oEvent.getParameter('selectedItem').getKey()), controller);
            }
        });
       // this.subledgerSelect.bindItems("/subledgers", subledgerTemplate, null);
        this.subledgerSelect.bindItems("/domains/0/subledgers", subledgerTemplate, null);

        var versionTemplate = new sap.ui.core.Item({
            text: "{version}",
            tooltip: "{version}",
            key: "{version}"
        });
        this.versionSelectLabel = new sas.hc.m.Label({
            text: rb.getText("subledgerAccountingManagerDialog.versionSelect.label")
        });
        this.versionSelect = new sas.hc.m.Input({
            id: "subledgerDialog.versionInput",
            //value: "{/subledgerData/version}",
            type: sap.m.InputType.Text,
            disableValidation:false,
            maxLength: 64,
            liveChange: $.proxy(controller.handleSubledgerVersionChange, controller),
            //change: $.proxy(controller.handleSubledgerVersionChange, controller),
        });

        var verticalLayout = new sas.hc.ui.layout.VerticalLayout({
            content: [
                new sas.hc.ui.layout.VerticalLayout({
                    content: [
                        this.domainSelectLabel,
                        this.domainSelect
                    ]
                }),

                new sas.hc.ui.layout.VerticalLayout({
                    content: [
                        this.subledgerSelectLabel,
                        this.subledgerSelect
                    ]
                }),
                new sas.hc.ui.layout.VerticalLayout({
                    content: [
                        this.versionSelectLabel,
                        this.versionSelect
                    ]
                })
                ]
        });

        var dialog = new sas.hc.m.Dialog({
            id: this.createId("sas.stress.config.view.CreateSubledgerAccountingDialog"),
            //modal: true,
            title: rb.getText("subledgerAccountingManagerDialog.window.title"),
            //initialFocus: searchField,

            content: verticalLayout,
            beginButton: new sas.hc.m.Button({
                id: this.createId("subledgerAccountingManagerDialog.createButton"),
                text: rb.getText("subledgerAccountingManager.create.button.label"),
                press: $.proxy(controller.createSubledgerAccountingButtonPress, controller),
                enabled: true //will be enabled when a hierarchy is selected in the table.
            }),
            endButton: new sas.hc.m.Button({
                text: rb.getText("button.cancel.action.label"),
                press: function () {
                    dialog.close();
                }
            }),
            afterClose: function () {
                dialog.destroy();
            }
        });

        return dialog;
    }
});