jQuery.sap.require({ modName: "sas.stress.config.view.SubledgerAccountingManager", type: "controller" });
jQuery.sap.require("sap.ui.core.HorizontalAlign");
jQuery.sap.require("sap.ui.model.Sorter");
jQuery.sap.require("sas.hc.ui.layout.Splitter");
jQuery.sap.require("sas.hc.ui.layout.SplitterLayoutData");
jQuery.sap.require("sas.hc.ui.table.Column");
jQuery.sap.require("sas.hc.ui.table.Table");
jQuery.sap.require("sas.hc.m.Menu");
jQuery.sap.require("sas.hc.m.MenuItem");
jQuery.sap.require("sas.hc.m.MenuButton");
jQuery.sap.require("sas.hc.m.ResponsiveToolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.risk.common.widgets.RiskPage");
jQuery.sap.require("sas.risk.common.widgets.RiskToolbar");
jQuery.sap.require("sas.risk.common.widgets.WidgetFactory");
jQuery.sap.require("sas.risk.common.widgets.ZeroStateLayout");
jQuery.sap.require("sas.stress.config.ConfigUtil");

sap.ui.jsview("sas.stress.config.view.SubledgerAccountingManager", {

    getControllerName: function () {
        return "sas.stress.config.view.SubledgerAccountingManager";
    },

    createContent: function (controller) {
        this.setHeight("100%");
        return this._createSubledgerAccountingPanel(controller);
    },

    _createSubledgerAccountingPanel: function (controller) {
        return sas.risk.common.widgets.WidgetFactory.buildPanel({
            content: this._createSubledgerAccountingTable(controller)
        });
    },

    _createSubledgerAccountingTable: function (controller) {

        this.subledgerAccountingTable = new sas.hc.ui.table.Table({
            id: "SubledgerAccountingTable",
            visibleRowCountMode: sas.hc.ui.table.VisibleRowCountMode.Auto,
            minAutoRowCount: 1,
            selectionMode: sas.hc.ui.table.SelectionMode.Single,
            showTableOptions: true,
            showSelectionControls: true,
            toolbar: this._createSubledgerAccountingTableToolbar(controller),
            rowSelectionChange: $.proxy(controller.onRowSelectionChange, controller),
            noData: "{i18N>subledgerAccountingManager.subledgerAccountingTable.noData.txt}",
            width:"100%"
        });

        this.subledgerAccountingTable.addColumn(new sas.hc.ui.table.Column({
            id:this.createId("SubledgerDomainName"),
            label: new sas.hc.m.Label({ text: "{i18N>subledgerAccountingManager.subledgerAccountingTable.column.domainName.header.title}" }),
            template: new sas.hc.m.Text({
                wrapping: false,
                tooltip: "{name}",
                text: "{name}"
            }),
            sortProperty: "name",
            width:"15rem"
        }));
        this.subledgerAccountingTable.addColumn(new sas.hc.ui.table.Column({
            id:this.createId("SubledgerName"),
            label: new sas.hc.m.Label({ text: "{i18N>subledgerAccountingManager.subledgerAccountingTable.column.subledgerName.header.title}" }),
            template: new sas.hc.m.Text({
                wrapping: false,
                tooltip: "{subledgerName}",
                text: "{subledgerName}"
            }),
            sortProperty: "subledgerName"
        }));
        this.subledgerAccountingTable.addColumn(new sas.hc.ui.table.Column({
            id:this.createId("SubledgerVersion"),
            label: new sas.hc.m.Label({ text: "{i18N>subledgerAccountingManager.subledgerAccountingTable.column.version.header.title}" }),
            template: new sas.hc.m.Text({
                wrapping: false,
                tooltip: "{version}",
                text: "{version}"
            }),
            sortProperty: "version"
        }));
        // this.subledgerAccountingTable.addColumn(new sas.hc.ui.table.Column({
        //     id:this.createId("SubledgerDomainId"),
        //     label: new sas.hc.m.Label({ text: "{i18N>subledgerAccountingManager.subledgerAccountingTable.column.domainId.header.title}" }),
        //     template: new sas.hc.m.Text({
        //         wrapping: false,
        //         //tooltip: "{id}",
        //         tooltip: "Id",
        //         text: "{domainId}"
        //     }),
        //     sortProperty: "id"
        //     //width:"10%"
        // }));
        //
        // this.subledgerAccountingTable.addColumn(new sas.hc.ui.table.Column({
        //     id:this.createId("SubledgerId"),
        //     label: new sas.hc.m.Label({ text: "{i18N>subledgerAccountingManager.subledgerAccountingTable.column.subledgerId.header.title}" }),
        //     template: new sas.hc.m.Text({
        //         wrapping: false,
        //         tooltip: "Id",
        //         text: "{subledgerId}"
        //     }),
        //     sortProperty: "subledgerId",
        // }));
        this.subledgerAccountingTable.addColumn(new sas.hc.ui.table.Column({
            id:this.createId("CreationDate"),
            label: new sas.hc.m.Label({ text: "{i18N>subledgerAccountingManager.subledgerAccountingTable.column.creationDate.header.title}" }),
            template: new sas.hc.m.Text({
                wrapping: false,
                tooltip: {
                    path: "creationDate",
                    formatter: sas.stress.config.ConfigUtil.formatDateTime
                },
                text: {
                    path: "creationDate",
                    formatter: sas.stress.config.ConfigUtil.formatDateTime
                }
            }),
            sortProperty: "creationDate"
            //width:"15%"
        }));

        this.subledgerAccountingTable.bindRows("/FlatDomains");

        var bindingInfo = this.subledgerAccountingTable.getBindingInfo("rows");
        if (bindingInfo) {
            bindingInfo.sorter = [new sap.ui.model.Sorter("subledgerAccountingName", false)];
        }
        return this.subledgerAccountingTable;
    },

    _createSubledgerAccountingTableToolbar: function (controller) {

        this.createButton = new sas.hc.m.Button({
            icon: sas.icons.HC.NEWSTARBURST,
            tooltip: "{i18N>subledgerAccountingManager.create.button.tip}",
            press: $.proxy(controller.onCreateClick, controller),
            enabled: true
        });

        this.editButton = new sas.hc.m.Button({
            icon: sas.icons.HC.EDIT,
            tooltip: "{i18N>subledgerAccountingManager.edit.button.tip}",
            press: $.proxy(controller.onEditClick, controller),
            enabled: false
        });

        this.refreshButton = new sas.hc.m.Button({
            icon: sas.icons.HC.REFRESH,
            tooltip: "{i18N>subledgerAccountingManager.refresh.button.tip}",
            press: $.proxy(controller.onRefreshClick, controller),
            enabled: true
        });

        this.deleteButton = new sas.hc.m.Button({
            icon: sas.icons.HC.DELETE,
            tooltip: "{i18N>subledgerAccountingManager.delete.button.tip}",
            press: $.proxy(controller.onDeleteClick, controller),
            enabled: false
        });


        return new sas.hc.m.ResponsiveToolbar({
            content: [
                this._createSubledgerAccountingFilter(controller),
                new sas.hc.m.ToolbarSpacer(),
                this.createButton,
                this.editButton,
                this.refreshButton,
                this.deleteButton
            ]
        });
    },

    _createSubledgerAccountingFilter: function (controller) {
        this.searchField = new sas.hc.m.SearchField({
            id: "SubledgerAccountingTableFilter",
            liveChange: $.proxy(controller.onFilterSubledgerAccounting, controller),
            search: $.proxy(controller.onFilterSubledgerAccounting, controller),
            filterMode: true
        });
        return this.searchField;
    },
    destroy: function() {
        //console.log("here");
    }
});