jQuery.sap.declare("sas.stress.data.model.DataLoadMapItemDetail");
jQuery.sap.require("sas.stress.data.DataAPI");

sap.ui.base.Object.extend("sas.stress.data.model.DataLoadMapItemDetail", {
    constructor: function (sourceVariableName,dataType,targetDimName,mapping,hierarchyName,hierarchyVersion,levelName) {
        this.sourceVariableName = sourceVariableName;
        this.dataType = dataType;
        this.targetDimName = targetDimName;
        this.mapping = mapping;
        this.hierarchyName = hierarchyName;
        this.hierarchyVersion = hierarchyVersion;
        this.levelName = levelName;

    }
});

sas.stress.data.model.DataLoadMapItemDetail.prototype.getSourceVariableName = function () {
    return this.sourceVariableName;
};

sas.stress.data.model.DataLoadMapItemDetail.prototype.getDataType= function () {
    return this.dataType;
};

sas.stress.data.model.DataLoadMapItemDetail.prototype.getTargetDimName = function () {
    return this.targetDimName;
};

sas.stress.data.model.DataLoadMapItemDetail.prototype.getMapping = function () {
    return this.mapping;
};

sas.stress.data.model.DataLoadMapItemDetail.prototype.getHierarchyName = function () {
    return this.hierarchyName;
};

sas.stress.data.model.DataLoadMapItemDetail.prototype.getHierarchyVersion = function () {
    return this.hierarchyVersion;
};

sas.stress.data.model.DataLoadMapItemDetail.prototype.getLevelName = function () {
    return this.levelName;
};

sas.stress.data.model.DataLoadMapItemDetail.getDataLoadMapDetails = function (DataLoadMapItemsJSON) {
    var deferred = $.Deferred();
    var DataLoadMapItemsDetail = [];
    _.each(DataLoadMapItemsJSON, function (DataLoadMapItemJSON) {
            var DataLoadMapItemDetail = new sas.stress.data.model.DataLoadMapItemDetail(DataLoadMapItemJSON.sourceVariableName,
                DataLoadMapItemJSON.dataType, DataLoadMapItemJSON.dimName,
                DataLoadMapItemJSON.mapping, DataLoadMapItemJSON.hierarchyName, DataLoadMapItemJSON.hierarchyVersion, DataLoadMapItemJSON.levelName
            );
            DataLoadMapItemsDetail.push(DataLoadMapItemDetail);
        });
    return DataLoadMapItemsDetail;
};

sas.stress.data.model.DataLoadMapItemDetail.getDataLoadMapDetailsForSelectedRow = function (rowIndex){
    var DataLoadMapItemsDetail = [];

    sas.stress.data.model.DataLoadMapItem.getDataLoadMap().done(function (DataLoadMapItems){
        var mapDataArray = DataLoadMapItems[rowIndex];
        var mapName = mapDataArray.getMapName();

        _.each(mapDataArray.variables, function (data) {
            var DataLoadMapItemDetail = new sas.stress.data.model.DataLoadMapItemDetail(data.sourceVariableName,
                data.dataType, data.dimName,
                data.mapping, data.hierarchyName, data.hierarchyVersion, data.levelName
            );
            DataLoadMapItemsDetail.push(DataLoadMapItemDetail);
        });
        DataLoadMapItemsDetail.push({"mapName":mapName});
        return DataLoadMapItemsDetail;
    }).fail(function(){
        return null;
    });


}