jQuery.sap.declare("sas.stress.wkbench.widget.Slimsheet");
jQuery.sap.require("sap.ui.core.Control");
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-core');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-widget');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-mouse');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-draggable');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-droppable');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-sortable');
jQuery.sap.require("sas.stress.wkbench.model.TreeNode");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.CellPickerUtil");
jQuery.sap.require("sas.stress.wkbench.parser.Math");

sap.ui.core.Control.extend("sas.stress.wkbench.widget.Slimsheet", {
	metadata:{
		properties:{
			slimsheetSource:{type:"any"}
		},
		events : {
			"cellSelected" : {allowPreventDefault : true},
			"cellDeSelected" : {allowPreventDefault: true},
			"rangeSelectCells":  {allowPreventDefault: true}
		}
	},
	constructor:function(){
		sap.ui.core.Control.apply(this,arguments);
		this.dom=null;
		this.firstCol=0;
		this.firstRow=0;
		this.selected=null;
		this.selecteds=[];
		this.ctrlKey = false;
		this.rb=sas.stress.wkbench.StressUtil.getBundle();
		this.sparklineCells=[];
	},
	renderer:function(rm, control){
		control.dom=null;
		rm.write("<div tabIndex='0' style='width: 100%; height: 100%' ");
		rm.addClass("StressSlimsheet");
		rm.writeClasses();
		rm.writeControlData(control);
		rm.write(">");
		rm.write("</div>");
	}
});

/*
 div.StressSlimsheet
 	|- div.StressSlimsheetBody
 		|-div.StressSlimsheetData
 			|- div.StressSlimsheetHeader
 				|-div.StressSlimsheetHeaderFixed
 					|-table-fixed
 				|-div.StressSlimsheetHeaderScrolled
 					|-table-scrolled
 			|- div.StressSlimsheetContent
 				|-div.StressSlimsheetContentFixed
 					|-table.fixed
 				|-div.StressSlimsheetContentScrolled
 					|-table.scrolled
 			|-div.StressSlimsheetVScrollbar
 		|- div.StressSlimsheetHScrollbar
 			|-div.scroller
 				|-div.stretcher
 */
sas.stress.wkbench.widget.Slimsheet.M_EVENTS = {'cellSelected':'cellSelected', 'cellDeSelected': 'cellDeSelected', 'rangeSelectCells': 'rangeSelectCells', 'cellExpandCollapse': 'cellExpandCollapse'};
sas.stress.wkbench.widget.Slimsheet.prototype.onBeforeRendering = function() {
	this.t0 = performance.now();
	var source=this.getSlimsheetSource();
	if(source){
		source.init();
	}
};
sas.stress.wkbench.widget.Slimsheet.prototype.onAfterRendering = function() {
	sas.stress.wkbench.widget.Slimsheet.renderTable(this,this.getDomRef());
	this.t1 = performance.now();
	console.info("Slimsheet UP in " + (this.t1 - this.t0) + " milliseconds; OR in " + (this.t1 - this.t0)/1000 + " seconds!!");
	var that=this;
	$(window).resize(function(){
		window.setTimeout($.proxy(that.onWindowResize,that),500);
	});

	//this._renderSparklines();
};

sas.stress.wkbench.widget.Slimsheet.prototype._renderSparklines = function() {
	var that=this;
	_.each(that.sparklineCells,function(sparklineCell){
		var cell=sas.stress.wkbench.widget.Slimsheet.findCell(that, sparklineCell.dataset.row, sparklineCell.dataset.col);
		//var parent=cell.parentElement;
		var sparkLineClassName="dynamicsparkline_"+sparklineCell.dataset.row+"_"+sparklineCell.dataset.col;
		//cell.innerHTML="752,772,792,1564,-812";
		//$(cell).peity("line",{height:"20px",width:"124px", strokeWidth:"1.25", fill: "none"});
		cell.className+=" " + sparkLineClassName;
		$(cell).sparkline([752,772,792,1564,-812],{height:"22px",width:"128px", highlightSpotColor:'#000000', fillColor:false});
	});
};

sas.stress.wkbench.widget.Slimsheet.prototype.destroy=function(){
	if (document.getElementById(this.getId())) {
		document.getElementById(this.getId()).removeAttribute("onclick");
		document.getElementById(this.getId()).removeAttribute("ondblclick");
	}

	var elements;
	elements=document.getElementsByClassName("StressColResizer");
	while(elements[0]) {
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=document.getElementsByClassName("StressSlimsheetHeaderFixed");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=document.getElementsByClassName("StressSlimsheetHeaderScrolled");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=document.getElementsByClassName("StressSlimsheetContentFixed");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=document.getElementsByClassName("StressSlimsheetContentScrolled");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}

	elements=document.getElementsByClassName("StressSlimsheetHeader");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}

	elements=document.getElementsByClassName("StressSlimsheetContent");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=document.getElementsByClassName("StressSlimsheetData");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=document.getElementsByClassName("StressSlimsheetBody");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=document.getElementsByClassName("StressSlimsheetHScrollbar");
	while(elements[0]&&elements[0].firstChild){
		if (elements[0].firstChild.firstChild){
			elements[0].firstChild.removeChild(elements[0].firstChild.firstChild);
		}
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	if (this.dom) {
		this.dom.hbar.scroller.val.onscroll = null;
		var $scroller = this.dom.body.vbar.scroller.val;
		$scroller.removeEventListener("scroll", $.proxy(this.onRowScroll, this, this.dims), false);
		var $table = this.dom.body.data.contents.scrolled.table.val;
		$table.removeEventListener("wheel", $.proxy(this.onWheelRowScroll, this, this.dims), false);
	}

	elements=document.getElementsByClassName("StressSlimsheet");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	this.dom=null;
	this.dims=null;
	this.selectedCell=null;

	var source=this.getSlimsheetSource();
	source.destroy();
	delete source;

	delete this.dom;
	delete this.dims;
};
sas.stress.wkbench.widget.Slimsheet.prototype.onExit=function(/*e*/){
	if (sap.ui.core.Control.prototype){
		sap.ui.core.Control.prototype.destroy(true);
	}
};

sas.stress.wkbench.widget.Slimsheet.prototype.onSelectStart = function(e){
	e.preventDefault();
};

sas.stress.wkbench.widget.Slimsheet.prototype.onfocusin=function(e){
	console.info("in onFocus of slimsheet");
	if(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE) {
		var source = this.getSlimsheetSource();
		var currentCol = source.getSelectedColumn();
		var currentRow = source.getSelectedRow();
		if ((currentCol >= 0 && currentRow >= 0) && source.getCellRange().length === 0) {
			console.log("selecting:-- row-" + currentRow + " column-" + currentCol);
			var filter = source.getCellFilter(currentRow, currentCol);
			if (!this.selected) {
				this.selected = {
					row: currentRow,
					col: currentCol,
					filterId: filter/*scenarioId:scenarioId*/
				};
			}
			sas.stress.wkbench.widget.Slimsheet.selectCell(this,currentRow,currentCol,filter);
			// the cell has got the tabindex, therefore, the Slimsheet div should not have it anymore...
			var ctrl=document.getElementsByClassName("StressSlimsheet");
			ctrl[0].tabIndex=-1;
		}else if (source.getCellRange().length > 0){
			this.rangeSelectCells(source.getCellRange())
		}
	}
	e.preventDefault();
	e.stopPropagation();
	//this.selectCell(currentrow,currentcol,filter);
};
sas.stress.wkbench.widget.Slimsheet.prototype.onfocusout=function(e){
	console.info("out of Focus of slimsheet");
	if(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE) {
		//this.selected=undefined;
		var ctrl=document.getElementsByClassName("StressSlimsheet");
		ctrl[0].tabIndex=0;
	}
};
//----
sas.stress.wkbench.widget.Slimsheet.prototype.onkeydown=function(e){
	var control = this;
	var dims = control.dims;
	var selected = control.selected;
	if (selected) {
		var keycode = e.keyCode;
		var source = this.getSlimsheetSource();
		var info = source.getInfo();
		var currentRow = selected.row;
		var currentColumn = selected.col;
		var filter = source.getCellFilter(currentRow, currentColumn);
		var scrollPosition = 0;
		switch (keycode) {
			case 37:/*left arrow*/
				if ((currentColumn/* - 1*/) === 0) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
				if (currentColumn !== 0 && currentColumn === this.firstCol) {
					// the scrollposiition should be advanced by the width * num of cols
					var pos=(currentColumn - 1)-(dims.viewableCols-2);
					if (pos>0){
						scrollPosition = 132 * pos;
					}else{
						scrollPosition = 1;
					}
				}
				control.fireCellSelected({selected:true,row:currentRow,col:currentColumn-1,filter:source.getCellFilter(currentRow,currentColumn)});
				if (scrollPosition>0||(currentColumn-1)===0){
					window.setTimeout(function(){
						control.dom.hbar.scroller.val.scrollLeft = scrollPosition;
					},0);
				}
				break;

			case 38:/*up arrow*/
				if ((currentRow/* - 1*/) === 0) {
					return;
				}
				if (!e.ctrlKey) {
					sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
					if (currentRow !== 0 && currentRow === this.firstRow) {
						// the scrollposiition should be advanced by the width * num of cols
						var pos = (currentRow - 1) - (dims.viewableRows - 2);
						if (pos > 0) {
							scrollPosition = 30 * pos; //(dims.viewableRows-1); S1405809
						} else {
							scrollPosition = 1;
						}
					}
					control.fireCellSelected({
						selected: true,
						row: currentRow - 1,
						col: currentColumn,
						filter: source.getCellFilter(currentRow, currentColumn)
					});
					if (scrollPosition > 0 || currentRow <= 3) {
						window.setTimeout(function () {
							if (scrollPosition > 1) {
								control.dom.body.vbar.scroller.val.scrollTop = scrollPosition;
							} else {
								control.dom.body.vbar.scroller.val.scrollTop = 0;
							}
						}, 0);
					}
				} else if (e.ctrlKey) {
					sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);

					control.fireCellSelected({
						selected: true,
						row: 0,
						col: currentColumn,
						filter: source.getCellFilter(currentRow, currentColumn)
					});
					window.setTimeout(function () {
						control.dom.body.vbar.scroller.val.scrollTop = 0;
					}, 0);
				}
				break;

			case 39:/*right arrow*/
				if ((currentColumn + 1) === info.scrolled.colCount) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
				// if the initial col is not the firstcol
				if (currentColumn !== 0 && (dims.viewableCols-1) === (currentColumn+1-this.firstCol)) {
					// the scrollposiition should be advanced by the width * num of cols
					scrollPosition = 132 * (currentColumn+1);
				}
				control.fireCellSelected({selected:true,row:currentRow,col:currentColumn+1,filter:source.getCellFilter(currentRow,currentColumn)});
				if(scrollPosition>0){
					window.setTimeout(function(){
						control.dom.hbar.scroller.val.scrollLeft = scrollPosition;
					},0);
				}

				break;

			case 40:/*down arrow*/
				if ((currentRow + 1) === info.fixed.rowCount) {
					return;
				}
				if (!e.ctrlKey) {
					sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
					//if (currentRow !== 0 && (dims.viewableRows - 1) === (currentRow + 1 - this.firstRow)) {	// S1431432
						// the scrollposiition should be advanced by the width * num of cols
						scrollPosition = 30 * (currentRow);
					//}
					control.dom.body.vbar.scroller.val.scrollTop = scrollPosition;
					if (scrollPosition > 0) {
						window.setTimeout(function () {
							control.fireCellSelected({
								selected: true,
								row: currentRow + 1,
								col: currentColumn,
								filter: source.getCellFilter(currentRow, currentColumn)
							});

						}, 0);
					}
				} else if(e.ctrlKey){	// ctrl + down arrow = last row in excel
					sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
					// the scrollposiition should be advanced by the width * num of cols
					scrollPosition = 30 * (dims.maxScrolledRow);

					control.fireCellSelected({
						selected:true,
						row:(dims.maxScrolledRow+dims.viewableRows)-2,
						col:currentColumn,
						filter:source.getCellFilter(dims.maxScrolledRow,currentColumn)
					});
					if (scrollPosition>0) {
						window.setTimeout(function () {
							control.dom.body.vbar.scroller.val.scrollTop = scrollPosition;
						}, 0);
					}
				}

				break;

			case 33: 	// page up
				if (currentRow === 0 /*|| (currentRow <= dims.viewableRows)*/) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
				if (currentRow !== 0 && (currentRow - dims.viewableRows - 2) <= this.firstRow) {
					// the scrollposiition should be advanced by the width * num of cols
					var pos=(currentRow - dims.viewableRows - 2);
					if (pos>0){
						scrollPosition = 30 * pos; //(dims.viewableRows-1); S1405809
					}else{
						scrollPosition = 1;
					}
				}
				control.fireCellSelected({
					selected:true,
					row:this.firstRow>0 ? (this.firstRow - 1): this.firstRow,
					col:currentColumn,
					filter:source.getCellFilter(currentRow,currentColumn)});
				if (scrollPosition>0||currentRow<=3) {
					window.setTimeout(function () {
						if (scrollPosition>1){
							control.dom.body.vbar.scroller.val.scrollTop = scrollPosition;
						}else{
							control.dom.body.vbar.scroller.val.scrollTop = 0;
						}
					}, 0);
				}
				break;

			case 34:	// page down
				if ((currentRow + 1) === info.fixed.rowCount || (currentRow + dims.viewableRows >= info.fixed.rowCount)) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
				// the scrollposiition should be advanced by the width * num of cols
				scrollPosition = 30 * (currentRow + dims.viewableRows - 1);

				control.fireCellSelected({
					selected:true,
					row: (currentRow + dims.viewableRows),
					col:currentColumn,
					filter:source.getCellFilter(dims.maxScrolledRow,currentColumn)
				});
				if (scrollPosition>0) {
					window.setTimeout(function () {
						control.dom.body.vbar.scroller.val.scrollTop = scrollPosition;
					}, 0);
				}

				break;

			case 35:	// end
				if ((currentColumn + 1) === info.scrolled.colCount) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
				// if the initial col is not the firstcol
				scrollPosition = 132 * (dims.maxScrolledCol + dims.viewableCols);
				control.fireCellSelected({
					selected:true,
					row:currentRow,
					col:dims.maxScrolledCol-2 + dims.viewableCols,
					filter:source.getCellFilter(currentRow,currentColumn)
				});
				window.setTimeout(function(){
					control.dom.hbar.scroller.val.scrollLeft = scrollPosition;
				},0);
				break;

			case 36:	// home
				if (currentColumn === 0) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentColumn, currentRow, filter);
				control.fireCellSelected({selected:true,row:currentRow,col:0,filter:source.getCellFilter(currentRow,currentColumn)});
				window.setTimeout(function(){
					control.dom.hbar.scroller.val.scrollLeft = 0;
				},0);

				break;

			case 17:
				if (e.ctrlKey){
					//this.ctrlKey=true;
				}
				break;

			case 27:	//Esc
				sas.stress.wkbench.widget.Slimsheet.deSelectRange(control);
				this.scrollToAndSelectCell(currentRow, currentColumn);

				break;

			default:
				break;
		}
	}
};
//---
sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor=function(col,row,filter){
	var cellRef=new sas.stress.wkbench.model.CellRef(col,row,filter);
	var cellCommentEditor=sas.stress.wkbench.ViewManager.getCellCommentEditor(cellRef);
	if (cellCommentEditor){
		cellCommentEditor.fireEvent(cellCommentEditor.getId()+"_CLOSING",{"view":cellCommentEditor,"action":"CANCEL"});
	}
};

sas.stress.wkbench.widget.Slimsheet.prototype.onclick=function(e){
	var target=e.target;
	if (_.size(target.dataset)===0){
		target=e.target.parentElement;
		if (_.size(target.dataset)===0){
			target=target.firstElementChild;
		}
	}
	var source = this.getSlimsheetSource();
	if ((!e.shiftKey && !e.ctrlKey)) {

		var row = parseInt(target.dataset.row) + this.firstRow;
		var col = parseInt(target.dataset.col) + this.firstCol;

		sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(this);
		if (source.isSelectable(row, col) && target.tagName === "DIV" && target.id && target.id.indexOf("-scrolled-") !== -1) {
			this.fireCellSelected({
				selected: true,
				row: row,
				col: source.getRealColumn(col),
				filter: source.getCellFilter(row, col)
			});
		}
		this.selecteds = [];	// single selection done.. we should clear the range
		source.setCellRange([]);
	}else{
		if(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE) {
			if (e.shiftKey) {
				var currentRow = parseInt(target.dataset.row) + this.firstRow;
				var currentColumn = parseInt(target.dataset.col) + this.firstCol;

				var previousRow = this.selected ? this.selected.row : source.getSelectedRow();
				var previousColumn = this.selected ? this.selected.col : source.getSelectedColumn();

				var filter = /*this.selected ? this.selected.filterId :*/ source.getCellFilter(previousRow, previousColumn);
				var cellRange = {
					previousRow: previousRow > currentRow ? currentRow : previousRow,
					currentRow: previousRow > currentRow ? previousRow : currentRow,

					previousColumn: previousColumn > currentColumn ? currentColumn : previousColumn,
					currentColumn: previousColumn > currentColumn ? previousColumn : currentColumn,

					isCopySource: false,
					filterId: filter
				};

				this.fireCellDeSelected({
					selected: false,
					row: previousRow,
					col: source.getRealColumn(previousColumn),
					filter: filter
				});

				this.fireRangeSelectCells({
					rangeSelect: true,
					cellRange: cellRange,
					filter: filter
				});
			}
		}
	}

	e.preventDefault();
	e.stopPropagation();
};
sas.stress.wkbench.widget.Slimsheet.prototype.ondblclick=function(e){
	var that=this;
	var ID = that.getId();
	var target=e.target;
	if (_.size(target.dataset)===0){
		target=e.target.parentElement;
	}
	var rowStr=target.dataset.row;
	var colStr=target.dataset.col;
	var source=this.getSlimsheetSource();
	if(!isNaN(rowStr) && !isNaN(colStr) && !source.isSelectable(parseInt(rowStr)+this.firstRow,parseInt(colStr)+this.firstCol)){
		return;
	}/*only show in place edit for selectable cells*/
	var filter=source.getCellFilter(rowStr,colStr);
	if (!filter.getSheetInfo().getData().isEditable(Number(rowStr)+this.firstRow,(Number(colStr))+this.firstCol)){
		return;
	}
	var id=this.getId()+"-inplace-edit";
	var inPlace=document.getElementById(id);
	var tester=document.getElementById(id+"-tester");
	var y=$(e.target).offset().top-$(window).scrollTop();
	var x=$(e.target).offset().left-$(window).scrollLeft();
	if(!inPlace){
		inPlace=document.createElement("TEXTAREA");
		inPlace.style.resize="both";
		inPlace.id=id;
		inPlace.className='StressSlimsheetInplace';
		$(inPlace).css({'font-size': ".875rem"});
		window.document.body.appendChild(inPlace);
		tester=document.createElement("DIV");
		tester.id=id+"-tester";
		$(tester).css({
			'position': 'absolute',
			'float': 'left',
			'white-space': 'nowrap',
			'visibility': 'hidden',
			'font-size': ".875rem"
		});
		window.document.body.appendChild(tester);

		$(inPlace).keydown(function(event){
			switch(event.keyCode){
				case 27:/*Esc*/
					sas.stress.wkbench.ViewManager.getCellEditor().cancelEditButton.firePress({});	// so that the text is not lost in IE
					sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(that, ID);
					break;
				case 13:/*Enter*/
					sas.stress.wkbench.ViewManager.getCellEditor().saveEditButton.firePress({ID: ID});	// so that the text is not lost in IE
					sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(that, ID);
					break;
			}
		});
		$(inPlace).keyup(function(event){
			switch(event.keyCode){
				case 27:/*Esc*/
				case 13:/*Enter*/
					break;
				// S1344039
				case 16:/*Shift*/
				case 17:/*Ctrl*/
				case 18:/*Alt*/
				case 35:/*Home*/
				case 36:/*End*/
				case 37:/*Left*/
				case 38:/*Up*/
				case 39:/*Right*/
				case 40:/*Down*/
					break;

				default:
					sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth(tester,inPlace);
					formulaField.setValue(inPlace.value);
					$(formulaField.getDomRef()).keypress();
					formulaField.fireLiveChange({});	// S1344039
					break;
			}
		});
		$(inPlace).blur(function(){
			// not defined... change iteration and come back noticed it that time
			var cellEditorView=sas.stress.wkbench.ViewManager.getCellEditor();
			var liveModel;
			var checkEditMode = sas.stress.wkbench.CellPickerUtil.NORMAL_MODE;
			if (cellEditorView) {
				liveModel = cellEditorView.getModel("live");
				try {
					checkEditMode = sas.stress.wkbench.CellPickerUtil.getOperationMode();
				} catch (e) {
					console.debug(e);
				}
			}
			switch(checkEditMode){	// RQSSTR-796
				case sas.stress.wkbench.CellPickerUtil.NORMAL_MODE:
				{
					sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(that);
					if (cellEditorView) {
						sas.stress.wkbench.ViewManager.getCellEditor().cancelEditButton.firePress({});
					}
					if (liveModel) {
						liveModel.setProperty("/inPlaceEditorId", null);
					}
				}
					break;

				case sas.stress.wkbench.CellPickerUtil.INPLACE_VISIBLE_MODE:	// RQSSTR-796
					// nothing to do as of now
					break;

				default:
					break;
			}
		});
	}
	var formulaField=sas.stress.wkbench.ViewManager.getCellEditor().formulaField;

	inPlace.rows=1;
	inPlace.style.visibility="visible";
	inPlace.spellcheck=false;
	inPlace.style.width=Math.max(source.getWidthOfText(formulaField.getValue())+24, $(e.target).width()+2)+"px";	// width = Max of cell width or the cell Value width
	inPlace.style.top=y+"px";
	inPlace.style.left=x+"px";
	inPlace.style.height=22*inPlace.rows+"px";

	inPlace.value=formulaField.getValue();
	sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth(tester,inPlace);
	$(formulaField.getDomRef()).focus();
	$(inPlace).focus();
	sas.stress.wkbench.ViewManager.getCellEditor().getController().gainedFocus();

	//$(inplace).focusout(function(){sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);});
	sas.stress.wkbench.StressUtil.setCaretPosition(id,inPlace.value.length);
	var liveModel=sas.stress.wkbench.ViewManager.getCellEditor().getModel("live");
	liveModel.setProperty("/inPlaceEditorId",id);
};

sas.stress.wkbench.widget.Slimsheet.prototype.selectCell=function(row,col,filterId){
	console.info("Cell Selected-2");
	var self = this;

	// we need this .. as of a HACK
	if (!this.selected){
		var previousSelectedRow = self.getSlimsheetSource().getSelectedRow();
		var previousSelectedColumn = self.getSlimsheetSource().getSelectedColumn();
		if (previousSelectedRow>-1 && previousSelectedColumn>-1){
			this.selected = {
				row: previousSelectedRow,
				col: previousSelectedColumn,
				filterId: filterId
			}
		}
	}

	if(this.selected){
		_.each(this.selecteds, function(selected){
			var calculatedColumn=self.getSlimsheetSource().getCalculatedColumn(selected.col);
			var prevSelectedCell=sas.stress.wkbench.widget.Slimsheet.findCell(self,selected.row,calculatedColumn);
			if(prevSelectedCell){
				$(prevSelectedCell).removeClass("SlimRangeSelectedTop");
				prevSelectedCell.dataset.selected = false;
				var id=self.getId();
				$("#"+id+" .SlimSelectedHeader").removeClass();
			}
		});

		var calculatedColumn=this.getSlimsheetSource().getCalculatedColumn(this.selected.col,this.selected.filterId/*scenarioId*/);
		var prevSelectedCell=sas.stress.wkbench.widget.Slimsheet.findCell(this,this.selected.row,calculatedColumn);
		if(prevSelectedCell){
			$(prevSelectedCell).removeClass("SlimSelected");
			prevSelectedCell.dataset.selected = false;
			var id=this.getId();
			$("#"+id+" .SlimSelectedHeader").removeClass();
		}
	}

	sas.stress.wkbench.widget.Slimsheet.deSelectRange(this);
	this.selecteds = [];	// clear the range
	this.selected={
		row:row,
		col:col,
		filterId:filterId
	};

	sas.stress.wkbench.widget.Slimsheet.selectCell(this,row,col,filterId);
	if (prevSelectedCell){
		$(prevSelectedCell).parent().parent()[0].tabIndex=-1;
	}
	// set the selected on the source so that when the sheet is selected and focussed, this row col gets highlighted
	if(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE) {
		this.getSlimsheetSource().setSelectedColumn(col);
		this.getSlimsheetSource().setSelectedRow(row);
	}
};

sas.stress.wkbench.widget.Slimsheet.prototype.deSelectCell=function(row,col,filterId){
	console.info("Cell De-Selected");
	this.getSlimsheetSource().setSelectedColumn(-1);
	this.getSlimsheetSource().setSelectedRow(-1);

	var source=this.getSlimsheetSource();
	var id=this.getId();
	var calculatedColumn = source.getCalculatedColumn(col, filterId);
	var prevSelectedCell = sas.stress.wkbench.widget.Slimsheet.findCell(this, row, calculatedColumn);
	if (prevSelectedCell) {
		$(prevSelectedCell).removeClass("SlimSelected");
		prevSelectedCell.dataset.selected=false;
	}

	//un-Highlight col headears.. first and last
	$("#"+id+"-head-scrolled-0"+"x"+calculatedColumn).parent().removeClass("SlimSelectedHeader");
	$("#"+id+"-head-scrolled-"+source.getColumnHeadersCount()+"x"+calculatedColumn).parent().removeClass("SlimSelectedHeader");
	//un-Highlight row headears.. first and last
	$("#"+id+"-fixed-"+calculatedColumn+"x"+0).parent().removeClass("SlimSelectedHeader");
	$("#"+id+" .SlimSelectedHeader").removeClass();
};

sas.stress.wkbench.widget.Slimsheet.prototype.rangeSelectCells = function(cellRange, filterId) {
	console.info("Range Select Cells");

	var self = this;
	var source=this.getSlimsheetSource();
	filterId = filterId || cellRange[0].filterId;
	sas.stress.wkbench.widget.Slimsheet.deSelectRange(self);
	if (cellRange.constructor === Array){
		_.each(cellRange, function(eachCell){
			self.fireCellDeSelected({
				selected: false,
				row: eachCell.row,
				col: source.getRealColumn(eachCell.col),
				filter: eachCell.filterId
			});
		})
	}else {
		self.fireCellDeSelected({
			selected: false,
			row: self.selected ? self.selected.row : cellRange.previousRow,
			col: source.getRealColumn(self.selected ? self.selected.col : cellRange.previousColumn),
			filter: filterId
		});

		self.selecteds = [];


		cellRange.filter = filterId;
		source.setCellRange(cellRange, filterId);

		for (var rowIndex = cellRange.previousRow; rowIndex <= cellRange.currentRow; rowIndex++) {
			for (var columnIndex = cellRange.previousColumn; columnIndex <= cellRange.currentColumn; columnIndex++) {
				var selected = {
					row: rowIndex,
					col: columnIndex,
					filterId: filterId
				};
				self.selecteds.push(selected);
			}
		}
	}

	sas.stress.wkbench.widget.Slimsheet.rangeSelectCells(self, cellRange, filterId);
};
sas.stress.wkbench.widget.Slimsheet.prototype.onWindowResize=function(e){
	console.log("SlimSheet::onWindowResize:" + e);
	if (this.dom) {
		if (this.dom.body && this.dom.body.val) {	// S1419385
			$(this.dom.body.val).remove();
		}
		this.dom.body = null;
		if (this.dom.hbar && this.dom.hbar.val) {	// S1419385
			$(this.dom.hbar.val).remove();
		}
		this.dom.hbar = null;
		this.firstRow = 0;
		this.firstCol = 0;
		sas.stress.wkbench.widget.Slimsheet.renderTable(this, this.getDomRef());
	}
};
sas.stress.wkbench.widget.Slimsheet.prototype.onWheelRowScroll=function(dims,e){
	console.warn(e.deltaY,e,this.dom.body.vbar.scroller.val.scrollTop);
	this.dom.body.vbar.scroller.val.scrollTop+=e.deltaY;
};
sas.stress.wkbench.widget.Slimsheet.prototype.onColScroll=function(dims,e){
	console.info("Column Scrolled-1");
	var source = this.getSlimsheetSource(),
		info = source.getInfo();

	var max=e.target.scrollWidth-e.target.clientWidth;
	var val=e.target.scrollLeft;
	//this.firstCol=(val===0||max===0)?0:Math.ceil(dims.maxScrolledCol*val/max);	// used to be floor.. should it be floor? - Srini
	this.firstCol=(val===0||max===0)?0:sas.stress.wkbench.parser.Math.precisionRound(dims.maxScrolledCol*val/max,0); // S1405809
//	$(this.dom.body.data.headers.val).remove();//too slow
	this.dom.body.data.val.children[0].removeChild(this.dom.body.data.headers.scrolled.val);
//	$(this.dom.body.data.contents.val).remove();//too slow
	this.dom.body.data.val.children[1].removeChild(this.dom.body.data.contents.scrolled.val);
	//sas.stress.wkbench.widget.Slimsheet.renderTable(this,this.getDomRef());

	//this.dom.body.data.val.removeChild(this.dom.body.data.contents.val);
	sas.stress.wkbench.widget.Slimsheet.calcDimensions(this, info);

	// SCROLLED headers
	var divHeaders=this.dom.body.data.headers.val;
	//this.dom.body.data.headers={val:divHeaders};
	divHeaders.className="StressSlimsheetHeader";
	var divHeaderScrolled=document.createElement("DIV");
	this.dom.body.data.headers.scrolled={val:divHeaderScrolled};
	divHeaderScrolled.style.overflowX="hidden";
	divHeaderScrolled.className="stressSlimsheetHeaderScrolled";
	sas.stress.wkbench.widget.Slimsheet.renderTableHeader(this,info,dims,"scrolled");
	divHeaders.appendChild(divHeaderScrolled);
	this.dom.body.data.val.appendChild(divHeaders);

	//SCROLLED
	var divContents=this.dom.body.data.contents.val;
	divContents.className="StressSlimsheetContent";

	var divContentScrolled=document.createElement("DIV");
	this.dom.body.data.contents.scrolled={val:divContentScrolled};
	divContentScrolled.style.overflowX="hidden";
	divContentScrolled.className="StressSlimsheetContentScrolled";
	sas.stress.wkbench.widget.Slimsheet.renderTableContent(this,info,dims,source,"scrolled");
	divContents.appendChild(divContentScrolled);
	this.dom.body.data.val.appendChild(divContents);

	sas.stress.wkbench.widget.Slimsheet.decorateCells(this,source);

	this._renderSparklines();
};

sas.stress.wkbench.widget.Slimsheet.prototype.onRowScroll=function(dims,e){
	console.info("Row Scrolled-1");
	var max=e.target.scrollHeight-(e.target.offsetHeight);//IE doesnt calculate clientHeight
	var val=e.target.scrollTop;
	//this.firstRow=Math.ceil(dims.maxScrolledRow*val/max);	// it was floor.. should it be floor?- Srini
	this.firstRow=sas.stress.wkbench.parser.Math.precisionRound(dims.maxScrolledRow*val/max,0);	// S1405809
	var source=this.getSlimsheetSource();
	var info=source.getInfo();
	this.dom.body.data.val.removeChild(this.dom.body.data.contents.val);
	sas.stress.wkbench.widget.Slimsheet.fillInValues(this,info,dims,source);
};

sas.stress.wkbench.widget.Slimsheet.prototype.removeCellWithSelectedClass=function(){
	var $cell=$(".StressSlimsheet .SlimSelected");
	if ($cell&&$cell.hasClass("SlimSelected")){
		$cell.removeClass("SlimSelected");
		$cell.data('selected', false);
	}
	/*return;*/
};

sas.stress.wkbench.widget.Slimsheet.prototype.scrollToAndSelectCell=function(row,col,selectCell){
	var control = this;
	var source=control.getSlimsheetSource();
	var dims = control.dims;
	var vScrollPosition= -1, hScrollPosition=-1;

	if (source.getInfo().rowCount>dims.viewableRows) {
		if (row>=(this.firstRow+dims.viewableRows)){
			// the row is not in view
			vScrollPosition=30*row;
		}else{
			// the row is visible
			if (this.firstRow!==0){
				// the firstRow is not 0 and the row is more than the firstRow
				vScrollPosition=30*row;
			} else if (row > this.firstRow||row<=5){
				vScrollPosition=0;
			}
		}
	}
	if (source.getInfo().scrolled.colCount>dims.viewableCols) {
		if (col>=(this.firstCol+dims.viewableCols)){
			// the row is not in view
			hScrollPosition=132*col;
		}else{
			// the row is visible
			if (this.firstCol!==0){
				// the firstRow is not 0 and the row is more than the firstRow
				hScrollPosition=132*(col-1);
			} else if (col > this.firstCol||col<=5){
				hScrollPosition=0;
			}
		}
	}
	if (vScrollPosition>-1) {
		window.setTimeout(function () {
			if (vScrollPosition > 1 || row <= 3) {
				control.dom.body.vbar.scroller.val.scrollTop = vScrollPosition;
			}
			else{
				control.dom.body.vbar.scroller.val.scrollTop = 0;
			}
		}, 0);
	}
	if (hScrollPosition>-1) {
		window.setTimeout(function () {
			if (hScrollPosition > 1) {
				control.dom.hbar.scroller.val.scrollLeft = hScrollPosition;
			} else {
				control.dom.hbar.scroller.val.scrollLeft = 0;
			}
		}, 0);
	}

	selectCell=selectCell===undefined || selectCell === null?true:selectCell;
    if (selectCell) {
        control.fireCellSelected({selected:true,row:row,col:col,filter:source.getCellFilter(row,col)});
    }
};
/*
 //STATICS BEGIN HERE
 */
sas.stress.wkbench.widget.Slimsheet.selectCell = function(control,row,col,filterId) {
	var source=control.getSlimsheetSource();
	var calculatedColumn=source.getCalculatedColumn(col,filterId);//so compare can adjust
	var id=control.getId();
	$("#" + id + " .SlimSelectedHeader").removeClass();

	var calcRowIdx=row;
	var calcColIdx=calculatedColumn/*-control.firstCol*/; // TODO: should i be worrying about the firstcol moving??- SRINI
	var cell=sas.stress.wkbench.widget.Slimsheet.findCell(control,row,calculatedColumn);
	if(cell){
		$(cell).addClass("SlimSelected");	// $(cell).parent().parent()[0].addClass("SlimSelected")
		cell.dataset.selected=true;		// cell is selected
		$(cell).parent().parent()[0].tabIndex=0;
	}

	//Highlight col headears.. first and last
	console.log("adding header--> " + col);
	$("#" + id + "-head-scrolled-0" + "x" + calcColIdx).parent().addClass("SlimSelectedHeader");
	//$("#"+id+"-head-scrolled-"+source.getColumnHeadersCount()+"x"+calcColIdx).parent().addClass("SlimSelectedHeader");
	//Highlight row headears.. first and last
	$("#" + id + "-fixed-" + calcRowIdx + "x" + 0).parent().addClass("SlimSelectedHeader");
	//$("#rowH"+id+"-fixed-"+calcRowIdx+"x"+source.getRowHeadersCount()).parent().addClass("SlimSelectedHeader");
};

sas.stress.wkbench.widget.Slimsheet.rangeSelectCells = function(control, cellRange, filterId, selectHeader) {
	var source=control.getSlimsheetSource();
	var id=control.getId();

	var calculatedColumn,
		prevSelectedCell,
		rowIndex,
		columnIndex;

	var isCopySource=cellRange.isCopySource ? cellRange.isCopySource : false;
	selectHeader = selectHeader===undefined ? true : selectHeader;

	for (rowIndex = cellRange.previousRow; rowIndex <= cellRange.currentRow; rowIndex++) {
		for (columnIndex = cellRange.previousColumn; columnIndex <= cellRange.currentColumn; columnIndex++) {
			if (selectHeader) {
				//Highlight col headears.. first and last
				$("#" + id + "-head-scrolled-0" + "x" + columnIndex).parent().addClass("SlimSelectedHeader");
				//$("#"+id+"-head-scrolled-"+source.getColumnHeadersCount()+"x"+calcColIdx).parent().addClass("SlimSelectedHeader");
				//Highlight row headears.. first and last
				$("#" + id + "-fixed-" + rowIndex + "x" + 0).parent().addClass("SlimSelectedHeader");
				//$("#rowH"+id+"-fixed-"+calcRowIdx+"x"+source.getRowHeadersCount()).parent().addClass("SlimSelectedHeader");
			}else {
				$("#" + id + " .SlimSelectedHeader").removeClass();
			}
		}
	}
	for (columnIndex = cellRange.previousColumn; columnIndex <= cellRange.currentColumn; columnIndex++){
		calculatedColumn = source.getCalculatedColumn(columnIndex, filterId);
		prevSelectedCell = sas.stress.wkbench.widget.Slimsheet.findCell(control, cellRange.previousRow, calculatedColumn);
		if (prevSelectedCell) {
			if (isCopySource){
				if ($(prevSelectedCell).hasClass("SlimRangeSelectedTop")){
					$(prevSelectedCell).removeClass("SlimRangeSelectedTop")
				}
				$(prevSelectedCell).addClass("SlimRangeSelectedDashedTop");
			}else {
				$(prevSelectedCell).removeClass("SlimRangeSelectedDashedTop");
				$(prevSelectedCell).addClass("SlimRangeSelectedTop");
			}
			prevSelectedCell.dataset.selected = true;
		}

		calculatedColumn = source.getCalculatedColumn(columnIndex, filterId);
		prevSelectedCell = sas.stress.wkbench.widget.Slimsheet.findCell(control, cellRange.currentRow, calculatedColumn);
		if (prevSelectedCell) {
			if (isCopySource){
				if ($(prevSelectedCell).hasClass("SlimRangeSelectedBottom")){
					$(prevSelectedCell).removeClass("SlimRangeSelectedBottom")
				}
				$(prevSelectedCell).addClass("SlimRangeSelectedDashedBottom");
			}else {
				$(prevSelectedCell).removeClass("SlimRangeSelectedDashedBottom");
				$(prevSelectedCell).addClass("SlimRangeSelectedBottom");
			}
			prevSelectedCell.dataset.selected = true;
		}
	}

	for (rowIndex = cellRange.previousRow; rowIndex <= cellRange.currentRow; rowIndex++){
		calculatedColumn = source.getCalculatedColumn(cellRange.previousColumn, filterId);
		prevSelectedCell = sas.stress.wkbench.widget.Slimsheet.findCell(control, rowIndex, calculatedColumn);
		if (prevSelectedCell) {
			if (isCopySource){
				if ($(prevSelectedCell).hasClass("SlimRangeSelectedSideLeft")){
					$(prevSelectedCell).removeClass("SlimRangeSelectedSideLeft")
				}
				$(prevSelectedCell).addClass("SlimRangeSelectedSideDashedLeft");
			}else {
				$(prevSelectedCell).removeClass("SlimRangeSelectedSideDashedLeft");
				$(prevSelectedCell).addClass("SlimRangeSelectedSideLeft");
			}
			prevSelectedCell.dataset.selected = true;
		}

		calculatedColumn = source.getCalculatedColumn(cellRange.currentColumn, filterId);
		prevSelectedCell = sas.stress.wkbench.widget.Slimsheet.findCell(control, rowIndex, calculatedColumn);
		if (prevSelectedCell) {
			if (isCopySource){
				if ($(prevSelectedCell).hasClass("SlimRangeSelectedSideRight")){
					$(prevSelectedCell).removeClass("SlimRangeSelectedSideRight")
				}
				$(prevSelectedCell).addClass("SlimRangeSelectedSideDashedRight");
			}else {
				$(prevSelectedCell).removeClass("SlimRangeSelectedSideDashedRight");
				$(prevSelectedCell).addClass("SlimRangeSelectedSideRight");
			}
			prevSelectedCell.dataset.selected = true;
			$(prevSelectedCell).parent().parent()[0].tabIndex=0;
		}
	}
};

sas.stress.wkbench.widget.Slimsheet.deSelectRange = function(control){
	var id=control.getId();

	$("#" + id + " .SlimRangeSelectedTop").removeClass("SlimRangeSelectedTop");
	$("#" + id + " .SlimRangeSelectedBottom").removeClass("SlimRangeSelectedBottom");
	$("#" + id + " .SlimRangeSelectedSideLeft").removeClass("SlimRangeSelectedSideLeft");
	$("#" + id + " .SlimRangeSelectedSideRight").removeClass("SlimRangeSelectedSideRight");

	$("#" + id + " .SlimRangeSelectedDashedTop").removeClass("SlimRangeSelectedDashedTop");
	$("#" + id + " .SlimRangeSelectedDashedBottom").removeClass("SlimRangeSelectedDashedBottom");
	$("#" + id + " .SlimRangeSelectedSideDashedLeft").removeClass("SlimRangeSelectedSideDashedLeft");
	$("#" + id + " .SlimRangeSelectedSideDashedRight").removeClass("SlimRangeSelectedSideDashedRight");

	$("#" + id + " .SlimSelectedHeader").removeClass();
};


sas.stress.wkbench.widget.Slimsheet.decorateCells = function(control,source) {
	$(".StressSlimsheet .SlimCommented .SlimValidationError").removeAttr("onmouseover").removeAttr("onmouseout");
	$(".StressSlimsheet .StressSlimsheetContent .StressSlimsheetContentScrolled td>span>div:first-child").removeClass();
	$(".StressSlimsheet .StressSlimsheetContent .StressSlimsheetContentFixed td+td>span>div.SlimHierarchyRoot").removeClass();
	if(control.selected){
		var selected=control.selected;
		sas.stress.wkbench.widget.Slimsheet.selectCell(control,selected.row,selected.col,selected.filterId);
	} else if (source.getCellRange()&&control.selecteds.length){	// cell range
		var cellRange= source.getCellRange();
		sas.stress.wkbench.widget.Slimsheet.rangeSelectCells(control, cellRange, control.selecteds[0].filterId);
	}
	source.decorateCells(control);
};
sas.stress.wkbench.widget.Slimsheet.findCell = function(control,rowIdx,colIdx,isFixed) {
	var prefix="-"+(isFixed?"fixed":"scrolled")+"-";
	if (control.dom) {
		if (control.dom.body.data.contents.scrolled) {
			var rowInfo = control.dom.body.data.contents.scrolled.table.tr;
			if (rowInfo[0]) {
				if (rowIdx >= control.firstRow && (rowIdx <= control.firstRow + rowInfo.length || rowIdx <= (control.dims.maxScrolledRow + control.dims.viewableRows -2))) {
					if (colIdx >= control.firstCol && (colIdx <= control.firstCol + rowInfo[0].length) || (colIdx <= (control.dims.maxScrolledCol + control.dims.viewableCols -2))) {
						var calcRowIdx = rowIdx - control.firstRow;
						var calcColIdx = colIdx - control.firstCol;
						var id = control.getId() + prefix + calcRowIdx + "x" + calcColIdx;
						return document.getElementById(id);
					}
				}
			}
		}
	}
	return null;
};
sas.stress.wkbench.widget.Slimsheet.findRow = function(control,rowIdx) {
	var colIdx;
	var cells=[];
	var rowInfo=control.dom.body.data.contents.scrolled.table.tr;
	if(rowIdx>=control.firstRow && rowIdx<=control.firstRow+rowInfo.length){
		var calcRowIdx=rowIdx-control.firstRow;
		var partialId=control.getId()+"-scrolled-"+calcRowIdx+"x";
		if (rowInfo[0]) {
			for (colIdx = control.firstCol; colIdx <= control.firstCol + rowInfo[0].length; colIdx++) {
				var calcColIdx = colIdx - control.firstCol;
				var id = partialId + calcColIdx;
				cells.push(document.getElementById(id));
			}
		}
	}
	return cells;
};
sas.stress.wkbench.widget.Slimsheet.renderTable = function(control, parent) {
	control.dom=control.dom||{val:parent};
	var source=control.getSlimsheetSource();
	if(!source){
		return;
	}
	var info=source.getInfo();
	if (info) {
		var dims = sas.stress.wkbench.widget.Slimsheet.calcDimensions(control, info);
		sas.stress.wkbench.widget.Slimsheet.createStructure(control, info, dims, source);
		sas.stress.wkbench.widget.Slimsheet.decorateCells(control, source);
		sas.stress.wkbench.widget.Slimsheet.createColumnResizers(control);
	}
};
//VALUES
sas.stress.wkbench.widget.Slimsheet.fillInValues = function(control,info,dims,source) {
	//sas.stress.wkbench.widget.Slimsheet._fillInValues(control,info,dims,source,"fixed");renderTableContents
	sas.stress.wkbench.widget.Slimsheet.calcDimensions(control,info);
	sas.stress.wkbench.widget.Slimsheet.renderTableContents(control,info,dims,source,"fixed");
	//sas.stress.wkbench.widget.Slimsheet._fillInValues(control,info,dims,source,"scrolled");
	sas.stress.wkbench.widget.Slimsheet.decorateCells(control,source);
};
sas.stress.wkbench.widget.Slimsheet._fillInValues = function(control,info,dims,source,prefix) {
	var i,j,row,col,inRange,tds,values;
	var isScrolled=prefix==="scrolled";
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var firstCol=isScrolled?control.firstCol:0;
	var lastCol=isScrolled?Math.min(firstCol+colCount,info.scrolled.colCount):firstCol+colCount;
	var rowCount=dims.viewableRows;
	var lastRow=control.firstRow+rowCount;
	var table=control.dom.body.data.contents[isScrolled?"scrolled":"fixed"].table;
	var getValueFunc=isScrolled?source.getScrolledRowData:source.getFixedRowData;
	for(i=0,row=control.firstRow;row<lastRow;i++,row++){
		inRange=row<info.rowCount;
		tds=table.tr[i];
		values=inRange?getValueFunc.call(source,row):null;
		var formatter=source.getFormatter(row);
		for(j=0,col=firstCol;col<lastCol;j++,col++){
			if (tds[j]) {
				var value=source.getScrolledRowColumnValue(row,col);
				tds[j].text.nodeValue = inRange ? sas.stress.wkbench.widget.Slimsheet.formatValue(value, source, isScrolled, formatter) : "";
			}
		}
	}
};
//STRUCTURE
sas.stress.wkbench.widget.Slimsheet.createStructure = function(control,info,dims,source) {
	var reuse=!!control.dom.body;
	var divBody=reuse?control.dom.body.val:document.createElement("DIV");
	if(!reuse){
		control.dom.body={val:divBody};
		divBody.className="StressSlimsheetBody";
		var divData=document.createElement("DIV");
		control.dom.body.data={val:divData};
		divData.className="StressSlimsheetData";
	}
	sas.stress.wkbench.widget.Slimsheet.renderTableHeaders(control,info,dims);
	sas.stress.wkbench.widget.Slimsheet.renderTableContents(control,info,dims,source);
	if(!reuse){
		divBody.appendChild(divData);
	}
	if(!reuse){
		control.dom.val.appendChild(divBody);
	}
	sas.stress.wkbench.widget.Slimsheet.renderVertScrollBar(control,dims);
	sas.stress.wkbench.widget.Slimsheet.renderHorizScrollBar(control,dims);
};
//HEADERS
sas.stress.wkbench.widget.Slimsheet.renderTableHeaders = function(control,info,dims) {
	var divHeaders=document.createElement("DIV");
	control.dom.body.data.headers={val:divHeaders};
	divHeaders.className="StressSlimsheetHeader";
	//FIXED
	var divHeaderFixed=document.createElement("DIV");
	control.dom.body.data.headers.fixed={val:divHeaderFixed};
	divHeaderFixed.style.float="left";
	divHeaderFixed.className="StressSlimsheetHeaderFixed";
	sas.stress.wkbench.widget.Slimsheet.renderTableHeader(control,info,dims,"fixed");
	//sas.stress.wkbench.widget.Slimsheet.renderTableRowHiearchy(control,info,dims,"fixed");
	divHeaders.appendChild(divHeaderFixed);
	//SCROLLED
	var divHeaderScrolled=document.createElement("DIV");
	control.dom.body.data.headers.scrolled={val:divHeaderScrolled};
	divHeaderScrolled.style.overflowX="hidden";
	divHeaderScrolled.className="stressSlimsheetHeaderScrolled";
	sas.stress.wkbench.widget.Slimsheet.renderTableHeader(control,info,dims,"scrolled");
	divHeaders.appendChild(divHeaderScrolled);
	control.dom.body.data.val.appendChild(divHeaders);
};
sas.stress.wkbench.widget.Slimsheet.renderTableHeader = function(control,info,dims,prefix) {
	var j,th;
	var isScrolled=prefix==="scrolled";
	var table=document.createElement("TABLE");
	control.dom.body.data.headers[isScrolled?"scrolled":"fixed"].table={val:table};
	table.style.width=isScrolled?String(dims.scrolledClientWidth)+"px":String(dims.fixedWidth+8)+"px";
	table.style.tableLayout="fixed";
	var thead=document.createElement("THEAD");
	var theadtr=document.createElement("TR");
	var firstCol=isScrolled?control.firstCol:0;
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var lastCol=firstCol+colCount;
	var widths=isScrolled?info.scrolled.widths:info.fixed.widths;
	for(j=firstCol;j<lastCol;j++){
		th=document.createElement("TH");
		th.className=prefix+"-col-"+j;
		if (j===(lastCol-1)&&!isScrolled) {
			th.style.width = String(widths[j]+8) + "px";
		}else{
			th.style.width = String(widths[j]) + "px";
		}
		theadtr.appendChild(th);
	}
	thead.appendChild(theadtr);
	table.appendChild(thead);
	sas.stress.wkbench.widget.Slimsheet.renderTableHeaderLabels(control,info,dims,prefix);
	control.dom.body.data.headers[isScrolled?"scrolled":"fixed"].val.appendChild(table);
};
sas.stress.wkbench.widget.Slimsheet.renderTableHeaderLabels = function(control,info,dims,prefix) {
	var i,td,div,tr,labels,col,isGrouped,span;
	var isScrolled=prefix==="scrolled";
	var id=control.getId()+"-head-"+prefix+"-";
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var firstCol=isScrolled?control.firstCol:0;
	var lastCol=firstCol+colCount;
	var headerCount=info.headerCount;
	var groupCount=info.groupCount;
	var labelsInfo=isScrolled?info.scrolled:info.fixed;
	var table=control.dom.body.data.headers[isScrolled?"scrolled":"fixed"].table.val;
	for(i=0;i<headerCount;i++){
		labels=labelsInfo["label_"+i];
		tr=document.createElement("TR");
		var groupColumnCount= 0, groupColumnIndex= 0/*1*/,j= 0, rspan= 0, txt="",title="", format="1.2"; // S1472103
		if (firstCol!==0){
			groupColumnIndex=1;
		}
		for(col=firstCol;col<lastCol;col++){
			// if we are scrolling horizontally.. then the firstCol!=0
			if (isScrolled&&firstCol!==0) {
				if (groupColumnIndex===1&&j===0) {
					groupColumnIndex = firstCol;
					j=firstCol/*-1*/;
				}
			}
			if (isScrolled/*&&col!==0*//*&&headerrow*/){//||i!==(headerCount-1)
				if (/*(col!==0&&groupCount===1)&&*/col===groupColumnIndex) {
					var node=labels.nodes?labels.nodes[j]:undefined;
					if (node) {
						rspan = groupCount = this._calculateSpanOnHScroll(node,firstCol/*(firstCol-1)*/,col===firstCol);
						txt = node.getName();
						title=node.getDataKey();
						format=node.getFormat();// S1472103
					} else{
						rspan=groupCount=1;
						txt=labels[col];
					}
					j+=rspan;
					groupColumnIndex+=rspan;
					groupColumnCount=rspan;
				}
			} else {
				txt=labels?(labels[col]?labels[col]:" "):"";
			}
			isGrouped=isScrolled&& groupCount>1 /*&& col!==0*/ /*headerCount===3 && i===0 &&*/ ;
			if(isGrouped && (col!== (groupColumnIndex-groupColumnCount))){
				continue;
			}
			td=document.createElement("TD");
			if (!isScrolled){
				sas.stress.wkbench.widget.Slimsheet._provideBorderInFixedHeaderTable(i, col, td);
			}else{
				if (i===1) {
					td.style.borderTop = "0.0625rem solid #cccccc";
				}
			}
			// if node has a subtotalChild.. we need to style differently, else no styling.. current 2.3 behavior
			if (node&&sas.stress.wkbench.widget.Slimsheet._doesNodeHaveSubtotalChild(node)===false){
				if(isGrouped){
					td.colSpan=(j===0)?groupCount-((col-1)%groupCount):groupCount;
				}
				if (node.getDataKey()===undefined){// subtotal nodes will not have datakey
					td.className="stressSlimsheetHeaderScrolledNonSubtotalled";
				}else if (sas.stress.wkbench.widget.Slimsheet._doesNodeHaveSubtotalChild(node.getParent())){	// does node's parent have a subtotal?
					td.className+="stressResize ";
					if (!!!node.hasChildren){
						td.className+=" stressLeafNode";
					}
				}else{	// this is the leaf... therefore, apply different style
					td.className+="stressNonSubtotalResize";
					if (!!!node.hasChildren){
						td.className+=" stressLeafNode";
					}
				}
			}else{
				if (node) {
					td.className = "stressSlimsheetHeaderScrolledSubtotalled ";
				}
				if(isGrouped){
					td.colSpan=(j===0)?groupCount-((col-1)%groupCount):groupCount;
					td.className+="stressHighlightSubTotalRow";
				}else if (node&&(node.getDataKey()&&(""===node.getLiKey()||node.getChildren().length>0))){
					td.className+="stressHighlightSubTotalRow stressRemoveTopBorder";	// highlight the column, remove the top border..
				}else if (node&&(node.getDataKey()&&(""!==node.getLiKey()||node.getChildren().length===0))){
					td.className+="stressResize stressLeafNode";
				}
			}
			div=document.createElement("DIV");
			div.id=id+i+"x"+col;
			div.innerHTML=txt;
			td.appendChild(div);
			span=document.createElement("SPAN");
			if (!isScrolled) {
				if ((col===0)||(col===(lastCol-1))) {	// only the first and last fixed col will have a resizer
					span.className = "StressColResizerPlaceholder";
				}
			}else{
				span.className = "StressColResizerPlaceholder";
			}
			span.dataset.col=col;
			span.dataset.scrolled=isScrolled?1:0;
			td.appendChild(span);
			if (isScrolled) {	// the fixed columns do not have tool tips on hover
				switch (i) {
					case 0:	// this is the colmn short reference header
						td.title = txt;	// tooltip for the row in the header..
						break;
					default:
						var shockVars=node.getVariableShockInfo()?node.getVariableShockInfo():[];
						if (txt.length===0){
							if (shockVars.length===0) {
								td.title = control.rb.getText("slimsheet.td.tip.fmt.txt", [node ? node.getParent().getName() : "", node ? node.getParent().getDataKey() : title, node ? node.getParent().getFormat() : format]);	// tooltip for the row in the header..
							}else{
								switch(shockVars.length){
									case 1:
										shockVars="\u0009"+shockVars;
										break;
									default:
										var allVars="";
										_.each(shockVars,function(vars){
											if (allVars.length>0){
												allVars+="\n";
											}
											allVars+="\u0009"+vars;
										});
										shockVars=allVars;
										break;
								}
								td.title = control.rb.getText("slimsheet.td.with.shocks.tip.fmt.txt", [node ? node.getParent().getName() : "", node ? node.getParent().getDataKey() : title, node ? node.getParent().getFormat() : format, shockVars]);	// tooltip for the row in the header..
							}
						}else {
							if (shockVars.length===0) {
								td.title = control.rb.getText("slimsheet.td.tip.fmt.txt", [txt, title, format]);	// tooltip for the row in the header..
							}else{
								switch(shockVars.length){
									case 1:
										shockVars="\u0009"+shockVars;
										break;
									default:
										var allVars="";
										_.each(shockVars,function(vars){
											if (allVars.length>0){
												allVars+="\n";
											}
											allVars+="\u0009"+vars;
										});
										shockVars=allVars;
										break;
								}
								td.title = control.rb.getText("slimsheet.td.with.shocks.tip.fmt.txt", [txt, title, format, shockVars]);	// tooltip for the row in the header..
							}
						}
						break;
				}
			}

			tr.appendChild(td);
		}
		if (isScrolled&&i===0){ // this is the short column reference row
			tr.className="stressColShortReference";
		}
		table.appendChild(tr);
	}
};
sas.stress.wkbench.widget.Slimsheet._provideBorderInFixedHeaderTable=function(row, column, td){
	switch (row){
		case 0:	// row 0
			switch (column){
				case 0:	// column 0
					// provide the border left
					td.style.borderLeft="0.0625rem solid #cccccc";
					break;
				default:
					break;
			}
			break;
		case 1:	// row 1
			switch (column){
				case 0:	// column 0
					// provide the border left
					//td.style.borderLeft="0.0625rem solid #cccccc";
					break;
				default:
					// other columns
					//td.style.borderTop="0.0625rem solid #cccccc";
					break;
			}
		default:	// all other rows
			switch(column){
				case 0:	// column 0
					td.style.borderLeft="0.0625rem solid #cccccc";
					break;
				case 1:	// column 1
					// provide the border left
					//td.style.borderLeft="0.0625rem solid #cccccc";
					break;
				default:
					break;
			}
			break;
	}
};
sas.stress.wkbench.widget.Slimsheet.renderTableRowHiearchy = function(control,info,dims,prefix) {
	var i,td,div,tr,labels,isGrouped;
	var isScrolled=prefix==="scrolled";
	var id=control.getId()+"-head-"+prefix+"-";
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var firstCol=isScrolled?control.firstCol:1;
	var rowCount=info.fixed.rowCount;
	var groupCount=info.groupCount;

	var labelsInfo=isScrolled?info.scrolled:info.fixed;
	var table=control.dom.body.data.headers[isScrolled?"scrolled":"fixed"].table.val;
	for(i=0;i<rowCount;i++){
		labels=labelsInfo["label_"+i];
		tr=document.createElement("TR");
		var groupColumnCount= 0, groupColumnIndex= 1,j= 0, rspan= 0, txt="";
		for(var row=0;row<colCount;row++){
			if (row!==0){//||i!==(headerCount-1)
				if (row===groupColumnIndex) {
					var node=labels.nodes?labels.nodes[j]:undefined;
					if (node) {
						rspan = groupCount = this._calculateSpanOnHScroll(node,(firstCol-1),false);
						txt=node.getName();
					} else{
						rspan=groupCount=1;
						txt=labels[row];
					}
					/*txt = headerrow ?((headerrow.label[j])?headerrow.label[j]:" "):labels[col];*/
					j+=rspan;
					groupColumnIndex+=rspan;
					groupColumnCount=rspan;
				}
			} else {
				txt=labels[row]?labels[row]:" ";
			}
			isGrouped=groupCount>1 && /*headerCount===3 && i===0 &&*/ row!==0;
			//isGrouped=isScrolled&& groupCount>1 /*&& headerCount===3*/ && i<headerCount && col!==0;
			if(isGrouped && (row!== (groupColumnIndex-groupColumnCount))){
				continue;
			}
			td=document.createElement("TD");
			if(isGrouped){
				td.rowSpan=rspan;
			}
			div=document.createElement("DIV");
			div.id=id+i+"x"+j;
			//var text=labels[col]?labels[col]:" ";
			div.appendChild(document.createTextNode(txt));
			td.appendChild(div);

			tr.appendChild(td);
		}

		table.appendChild(tr);
	}
};
//CONTENTS
sas.stress.wkbench.widget.Slimsheet.renderTableContents = function(control,info,dims,source) {
	var divContents=document.createElement("DIV");
	control.dom.body.data.contents={val:divContents};
	divContents.className="StressSlimsheetContent";
	//FIXED
	var divContentFixed=document.createElement("DIV");
	control.dom.body.data.contents.fixed={val:divContentFixed};
	divContentFixed.style.float="left";
	divContentFixed.className="StressSlimsheetContentFixed";
	sas.stress.wkbench.widget.Slimsheet.renderTableContent(control,info,dims,source,"fixed");
	divContents.appendChild(divContentFixed);
	//SCROLLED
	var divContentScrolled=document.createElement("DIV");
	control.dom.body.data.contents.scrolled={val:divContentScrolled};
	divContentScrolled.style.overflowX="hidden";
	divContentScrolled.className="StressSlimsheetContentScrolled";
	sas.stress.wkbench.widget.Slimsheet.renderTableContent(control,info,dims,source,"scrolled");
	divContents.appendChild(divContentScrolled);
	control.dom.body.data.val.appendChild(divContents);
};
sas.stress.wkbench.widget.Slimsheet.renderTableContent = function(control,info,dims,source,prefix) {
	var i,j,th,inRange,tr,tds,values,td,row,col,formatter,div,txtspan;
	var isScrolled=prefix==="scrolled";
	var parent=control.dom.body.data.contents[isScrolled?"scrolled":"fixed"];
	var id=control.getId()+"-"+prefix+"-";
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var firstCol=isScrolled?control.firstCol:0;
	var lastCol=firstCol+colCount;
	var table=document.createElement("TABLE");
	parent.table={val:table};
	table.style.width=isScrolled?dims.scrolledClientWidth+"px":dims.fixedWidth+8+"px";
	table.style.tableLayout="fixed";
	table.style.borderBottom="1px solid #dadada";	// border bottom to the table to provide closure
	//table.onwheel=$.proxy(control.onWheelRowScroll,control,dims);
	table.addEventListener("wheel",$.proxy(control.onWheelRowScroll,control,dims),{passive: true});

	var thead=document.createElement("THEAD");
	var theadtr=document.createElement("TR");
	var widths=isScrolled?info.scrolled.widths:info.fixed.widths;
	for(j=firstCol;j<lastCol;j++){
		th=document.createElement("TH");
		th.className=prefix+"-col-"+j;
		if (j===(lastCol-1)&&!isScrolled) {
			th.style.width = String(widths[j]+8) + "px";
		}else{
			th.style.width = String(widths[j]) + "px";
		}
		theadtr.appendChild(th);
	}
	thead.appendChild(theadtr);
	table.appendChild(thead);
	var trs=[];
	var rowCount=dims.viewableRows;
	var lastRow=control.firstRow+rowCount;


	// if the info has row headers then we will display otherways
	if (!isScrolled&&colCount>=2){
		var divWidth=dims.fixedWidth-widths[0];
		//sas.stress.wkbench.widget.Slimsheet.renderTableRowHiearchy(control,info,dims,source,prefix);
		var labelsInfo=isScrolled?info.scrolled:info.fixed;
		var spans={};
		i=control.firstRow;
		for(row = control.firstRow; row < lastRow; i++, row++){
			if (row===info.rowCount){
				break;
			}
			var txt="",j= 0,title="", format="1.2";	
			tds = [];
			tr=document.createElement("TR");
			txt=(i+1).toLocaleString();
			td=document.createElement("TD");
			div=document.createElement("DIV");
			div.id=/*"rowH"+*/id+i+"x"+j;
			div.innerHTML=txt;//appendChild(document.createTextNode(txt));
			td.appendChild(div);
			tr.appendChild(td);

			for(var col= 1,j=1;col<colCount;col++,j++){
				var groupRowIndex= 0, span= 0, exists=false;
				var labels=labelsInfo["label_"+j];
				var node=labels.nodes?labels.nodes[i]:undefined;
				if (node) {
					if (control.firstRow === 0) {
						span = node.getName().length?this._calculateSpanOnHScroll(node, (firstCol - 1), false):1;	// if the name is "", it is empty or subtotal the span =1
					} else {
						span = node.getName().length?this._calculateSpanOnVScroll(node, row, i):1;	// if the name is "", it is empty or subtotal the span =1
					}
					txt = node.getName();
					title = node.getDataKey();
					format = node.getFormat();

					var data = {groupRowIndex: 0, previousRow: 0, span: 0};
					if (span > 1) {
						if (!(node.getUniqueID() in spans)) {/*LiKey*/
							data.groupRowIndex = groupRowIndex + span;
							data.previousRow = row;
							data.span = span;

							spans[node.getUniqueID()] = data;/*LiKey*/
						} else {
							data = spans[node.getUniqueID()];/*LiKey*/
							if (col !== 1) {
								var parentspan = this._calculateSpanOnHScroll(node.getParent(), (firstCol - 1), false);
								if (parentspan > 1) {
									data.groupRowIndex = parentspan;
								}
							}
							exists = true;
						}
					} else if (control.firstRow > 0 && node.getUniqueID() in spans) {/*LiKey*/
						exists = true;
					}

					if (exists === false/*|| data.span===1*/ || ( data.groupRowIndex + data.previousRow) === row) {
						td = document.createElement("TD");
						td.rowSpan = span;
						div = document.createElement("DIV");
						td.className = "stressSlimsheetHierarchyFixed";
						div.id = "rowH" + id + i + "x" + j;
						if (control.firstRow === 0) {
							if (col === 1) {
								div.style.width = divWidth - 8 + "px";
								div.style.maxWidth = divWidth - 8 + "px";
							} else if (col === (lastCol - 1)) {
								div.style.width = widths[j] + "px";
								div.style.maxWidth = widths[j] + "px";
							} else {
								div.style.width = divWidth - (widths[j] * (j - 1)) - 8 + "px";
								div.style.maxWidth = divWidth - (widths[j] * (j - 1)) - 8 + "px";
							}
						} else {
							if (span === 1 && node.getChildren() === 0) {	// make sure we are not looking at a sub-total node
								if (col === (lastCol - 1)) {
									div.style.width = widths[j] + "px";
									div.style.maxWidth = widths[j] + "px";
								} else {
									div.style.width = divWidth - (widths[j] * (j - 1)) - 8 + "px";
									div.style.maxWidth = divWidth - (widths[j] * (j - 1)) - 8 + "px";
								}
							} else {
								// if the label after the current is "", we can show the full name of the node.. else it will be truncated
								var oneAfter = labelsInfo["label_" + (col + 1)];
								var labelsAfter = oneAfter ? oneAfter.nodes[i].getName() : "";
								if ("" === labelsAfter) {
									div.style.width = divWidth - (widths[col - 1] * (col - 1)) - 8 + "px";
									div.style.maxWidth = divWidth - (widths[col - 1] * (col - 1)) - 8 + "px";
								}
							}
						}
						var text = document.createTextNode(txt);
						div.appendChild(text);
						td.appendChild(div);
						td.title=control.rb.getText("slimsheet.td.tip.fmt.txt",[txt,title, format]);//"Name: "+txt+"\nDataKey: "+title;
						if (txt.length===0) {
							td.className = "stressRemoveLeftAndRightwidth";
							td.title=control.rb.getText("slimsheet.td.tip.fmt.txt",[node.getParent().getName(),node.getParent().getDataKey(), node.getParent().getFormat()]);//"Name: "++"\nDataKey: "+;
						}
						if ((node.getDataKey()&&node.getSubtotalLikey()===undefined&&node.getChildren().length>0)/*&&!node.getLiKey()&&j<(colCount-1)*//*txt.length===0||j<(colCount-1)*/){    // the span is not 1 (usually emptynodes or if the node is not in the last column
							if (td.className) {
								td.className +=" ";
							}
							td.className+="stressHighlightSubTotalRow";
						} else if(node.getDataKey()&& node.getSubtotalLikey()&&node.getChildren().length===0){
							if (td.className) {
								td.className +=" ";
							}
							td.className+="stressHighlightSubTotalRow";
						} else if (node.getDataKey()&&node.getChildren().length===0){
							if (td.className) {
								td.className +=" ";
							}
							td.className+="stressLeafNode";
						}

						tds.push({td: td, div: div, text: text});

						tr.appendChild(td);
						// the pevious row needs to be updated to current row
						data.previousRow = row;
					}
				}
			}
			trs.push(tds);
			table.appendChild(tr);
		}
	} else {
		var getValueFunc = isScrolled ? source.getScrolledRowData : source.getFixedRowData;
		for (i = 0, row = control.firstRow; row < lastRow; i++, row++) {
			inRange = row < info.rowCount;
			if (inRange) {
				tr = document.createElement("TR");
				tds = [];
				values = inRange ? getValueFunc.call(source, row) : null;
				//formatter = source.getFormatter(row);
				for (j = 0, col = firstCol; col < lastCol; j++, col++) {
					formatter = source.getFormatterRowCol(row, col);
					td = sas.stress.wkbench.widget.Slimsheet.createCell(control, dims, source, tds, id, row, col, i, j, inRange, values, isScrolled, formatter);
					tr.appendChild(td);
				}
				trs.push(tds);
				table.appendChild(tr);
			}
		}
	}
	parent.table.tr=trs;
	parent.val.appendChild(table);
};
sas.stress.wkbench.widget.Slimsheet.createCell = function(control,dims,source,tds,id,row,col,i,j,inRange,values,isScrolled,formatter) {
	var td=document.createElement("TD");
	td.tabIndex=-1;
	var span=document.createElement("SPAN");
	var div=document.createElement("DIV");
	div.id=id+i+"x"+j;
	div.dataset.row=i;
	div.dataset.col=j;
	//$(div).css({ 'line-height': '20px' });

	div.dataset.selected=false;
	div.addEventListener("selectstart", $.proxy(control.onSelectStart, control), {passive: false});

	var value=source.getScrolledRowColumnValue(row,col);
	var txt=inRange?sas.stress.wkbench.widget.Slimsheet.formatValue(value,source,isScrolled,formatter):"";
	//var text=document.createTextNode(txt);
	tds.push({td:td,div:div/*,text:text*/});
	//div.innerHTML=txt;//.appendChild(text);

	var values;//=source.getSubtotalCellValues(row,col);
	if (values&&values.length) {
		var svg=sas.stress.wkbench.widget.Slimsheet.createAndPlaceGraph(control,txt,values);
		div.appendChild(svg);
		//control.sparklineCells.push(div);
	}else{
		div.innerHTML=txt;//.appendChild(text);
	}
	span.appendChild(div);
	td.appendChild(span);
	if(source.augmentCell){//hook to let the source customize the cell
		td=source.augmentCell(control,dims,source,id,row,col,i,j,inRange,values,isScrolled,td);
	}
	//td.title=txt==="&nbsp;"?null:txt;

	return td;
};
sas.stress.wkbench.widget.Slimsheet.formatValue = function(value,source,isScrolled,formatter) {
	if(isScrolled){
		if(value===null || value===undefined /*|| value===-1*/ || value===" "){	//fixes for S1298955
			return "&nbsp;";
		}
		try {
			return formatter.format(value);
		}catch(e){
			return value;
		}
	}
	return value;
};
sas.stress.wkbench.widget.Slimsheet.createAndPlaceGraph=function(control,txt,values) {
	//div.className="dynamicsparkline";
	//$(div).sparkline([18,10,16,70,8,100,21,15]);
	var ns = 'http://www.w3.org/2000/svg';

	var svg = document.createElementNS(ns, 'svg');

	svg.setAttributeNS(null,"width","100%");
	svg.setAttributeNS(null,"height","100%");
	svg.setAttributeNS(null,"version","1.1");
	svg.style.float="left";
	svg.style.display="block";
	svg.style.maxHeight="100%";
	svg.setAttributeNS(null,"viewBox", "0 0 124 20");
	svg.setAttributeNS(null,"preserveAspectRatio","xMinYMin meet");
	var title=document.createElementNS(null, "title");
	/*var text=document.createElementNS(ns, "text");
	 text.setAttributeNS(null,"x", "128");
	 text.setAttributeNS(null, "y", "16");
	 text.setAttributeNS(null,"font-size","0.835rem");
	 text.setAttributeNS(null,"text-anchor","end");*/
	title.innerHTML=txt;

	var polyLine=document.createElementNS(ns, 'polyline');
	polyLine.setAttributeNS(null,"fill","none");
	polyLine.setAttributeNS(null,"stroke","#003366");

	var height=19, width=124, strokeWidth=1;
	var max=Math.max.apply(Math,values),min=Math.min.apply(Math,values);
	var diff=max-min;
	var xScale /*= this.x*/ = function(input) {
		var val=input * ((width-2) / (values.length - 1));
		return isNaN(val)?0:val;
	};

	var yScale /*= this.y*/ = function(input) {
		var y = height-1;

		if (diff) {
			y -= ((input - min) / diff) * height;
		}

		return Math.abs(y) + strokeWidth / 2;
	};

	var zero = yScale(Math.max(min, 0))
		, coords = [0, zero];

	for (var i = 0; i < values.length; i++) {
		coords.push(
			xScale(i),
			yScale(values[i])
		);
	}

	coords.push(width, zero);

	var polygon=document.createElementNS(ns, 'polygon');
	polygon.setAttributeNS(null,"fill", "none");
	polygon.setAttributeNS(null,'points', coords.join(' '));

	var circleDataPoints=coords.slice(2, coords.length - 2).length>2?coords.slice(2, coords.length - 2).join(' '):coords.slice(2, coords.length).join(' ');
	polyLine.setAttributeNS(null,"points", circleDataPoints);
	polyLine.setAttributeNS(null,"stroke-width",strokeWidth);
	svg.title=txt;
	svg.appendChild(title);
	/*svg.appendChild(text);
	 text.innerHTML=txt;*/
	svg.appendChild(polygon);
	svg.appendChild(polyLine);

	var circleDataPts=circleDataPoints.split(' ').map(Number);
	var circleDataPointLength=circleDataPts.length/2;
	var cxIdx= 0, cyIdx=cxIdx+1;
	for (var circleDPIndex=0; circleDPIndex<circleDataPointLength;circleDPIndex++){
		var circle=document.createElementNS(ns, 'circle');
		circle.setAttributeNS(null, "cx", circleDataPts[cxIdx].toString());
		circle.setAttributeNS(null, "cy", circleDataPts[cyIdx].toString());
		circle.setAttributeNS(null, "r", "2");
		circle.setAttributeNS(null, "fill", "red");
		svg.appendChild(circle);

		cxIdx=cyIdx+1;
		cyIdx=cxIdx+1;
	}

	return svg;
};
//SCROLLBARS
sas.stress.wkbench.widget.Slimsheet.renderHorizScrollBar = function(control,dims) {
	var reuse=!!control.dom.hbar;
	var outerdiv=reuse?control.dom.hbar.val:document.createElement("DIV");
	if(!reuse){
		control.dom.hbar={val:outerdiv};
		outerdiv.className="StressSlimsheetHScrollbar";
	}
	outerdiv.style.paddingLeft=dims.fixedWidth+7+"px";/*helps align border of scroller div*/
	var div=reuse?control.dom.hbar.scroller.val:document.createElement("DIV");
	if(!reuse){
		control.dom.hbar.scroller={val:div};
	}
	div.style.left=dims.fixedWidth +"px";
	var innerdiv=reuse?control.dom.hbar.scroller.stretcher.val:document.createElement("DIV");
	if(!reuse){
		control.dom.hbar.scroller.stretcher={val:innerdiv};
		innerdiv.style.height="1px";
	}
	innerdiv.style.width=dims.scrolledWidth+"px";
	if(!reuse){
		div.appendChild(innerdiv);
		outerdiv.appendChild(div);
		control.dom.val.appendChild(outerdiv);
		var scrollPosition=dims.maxScrolledCol>0?((div.scrollWidth-div.clientWidth)*control.firstCol)/dims.maxScrolledCol:1;
		div.scrollLeft=scrollPosition;
	}
	div.onscroll=$.proxy(control.onColScroll,control,dims);
	//div.addEventListener("scroll",$.proxy(control.onColScroll,control,dims)/*,{passive:true}*/);
};
sas.stress.wkbench.widget.Slimsheet.renderVertScrollBar = function(control,dims) {
	var reuse=!!control.dom.body.vbar;
	if(!reuse){
		var $control=$(control.dom.val);
		var $scrolledheader=$.find(".stressSlimsheetHeaderScrolled");
		var outerdiv=document.createElement("DIV");
		control.dom.body.vbar={val:outerdiv};
		outerdiv.className="StressSlimsheetVScrollbar";
		outerdiv.style.paddingTop=($scrolledheader[0].offsetHeight/*dims.headerHeight+8*/)+"px";
		var div=document.createElement("DIV");
		control.dom.body.vbar.scroller={val:div};
		div.style.top=$scrolledheader[0].offsetHeight/*dims.headerHeight*/+"px";
		div.onscroll=$.proxy(control.onRowScroll,control,dims);
		//div.addEventListener("scroll",$.proxy(control.onRowScroll,control,dims),{passive:true});

		var innerdiv=document.createElement("DIV");
		control.dom.body.vbar.scroller.stretcher={val:innerdiv};
		innerdiv.style.width="1px";
		innerdiv.style.height=dims.contentHeight+"px";
		div.appendChild(innerdiv);
		outerdiv.appendChild(div);
		control.dom.body.val.appendChild(outerdiv);
		var scrollPosition=((div.scrollHeight-div.offsetHeight)*control.firstRow)/dims.maxScrolledRow;
		div.scrollTop=scrollPosition/*+1*/;
	}

};
//DIMENSIONS
sas.stress.wkbench.widget.Slimsheet.calcDimensions = function(control,info) {
	var dims=control.dims||{};
	control.dims=dims;//save reference
	var i;
	var fullOffsetWidth=control.dom.val.offsetWidth;
	var totalFixedColumnWidth=info.fixed.width;
	var totalScrolledColumnWidth=info.scrolled.width;
	var fullOffsetHeight=control.dom.val.offsetHeight;
	var totalHeaderRowHeight=info.headerCount*30/*+info.headerCount-2*/;// there is a 12-14px offset in the header height
	var totalContentRowHeight=info.rowCount*30-19;			// the height = total rows *30 (each row height)
	var scrolledOffsetWidth=fullOffsetWidth-totalFixedColumnWidth-19/*vert scrollbar*/;
	var contentOffsetHeight=fullOffsetHeight-totalHeaderRowHeight-19/*horiz scrollbar*/;	// the height of H scroll bar
	var colCount=info.scrolled.colCount;
	var viewableCols=0;
	var widths=info.scrolled.widths;
	var scrolledClientWidth=0;
	for(i=control.firstCol;i<colCount;i++){
		viewableCols++;
		scrolledClientWidth+=widths[i];
		if(scrolledClientWidth>scrolledOffsetWidth){
			break;
		}
	}
	var maxScrolledCol=0;
	var _clientWidth=0;
	for(i=colCount-1;i>=0;i--){
		_clientWidth+=widths[i];
		if(_clientWidth>scrolledOffsetWidth){
			break;
		}
		maxScrolledCol=i;
	}
	var rowCount=info.rowCount;
	var viewableRows=Math.min(Math.ceil(contentOffsetHeight/30),rowCount);
	var maxScrolledRow=Math.max(rowCount-viewableRows+1,0);
	control.firstRow=Math.min(control.firstRow,maxScrolledRow);
	dims.scrolledClientWidth=scrolledClientWidth;
	dims.fixedWidth=totalFixedColumnWidth;
	dims.scrolledWidth=totalScrolledColumnWidth;
	dims.scrolledOffsetWidth=scrolledOffsetWidth;
	dims.headerHeight=totalHeaderRowHeight;
	dims.contentHeight=totalContentRowHeight;
	dims.contentOffsetHeight=contentOffsetHeight;
	dims.viewableCols=viewableCols;
	dims.viewableRows=viewableRows;
	dims.maxScrolledRow=maxScrolledRow;
	dims.maxScrolledCol=maxScrolledCol;

	return dims;
};
//COLUMN RESIZER
sas.stress.wkbench.widget.Slimsheet.createColumnResizers=function(control){
	$(".StressColResizer").remove();
	var count=control.getSlimsheetSource().getInfo().headerCount;
	var $control=$(control.dom.val);
	var $contentsTable=$(control.dom.body.data.contents.val);
	var $headersTable=$control.find(".StressSlimsheetContentScrolled");
	var placeholders=$control.find(".StressColResizerPlaceholder");
	var headerTable=control.dom.body.data.headers.val;
	var $colShortReference=$control.find(".stressColShortReference");
	var i,placeholder,$placeholder,y,x,h,id,dataset,scrolled,col;
	for(i=0;i<placeholders.length;i++){
		placeholder=placeholders[i];
		dataset=placeholder.dataset;
		scrolled=dataset.scrolled;
		col=dataset.col;
		$placeholder=$(placeholder);
		//$control.offset().top-$(window).scrollTop()+44(headerTable.offsetHeight-18)*count; ////$control.find(".stressColShortReference").height()
		y=$control.offset().top+1;//(count<3?0:(count*10));//$control.offset().top-$(window).scrollTop()+count*12.75;//(count<2?0:50)
		x=$placeholder.offset().left-$(window).scrollLeft();
		h=$colShortReference.height();//headerTable.offsetHeight;//42+8;//$(headerTable).height();
		h2=$contentsTable.height() + (headerTable.offsetHeight-$colShortReference.height());
		id="stress-col-resizer-"+scrolled+"x"+col;
		var resizer=document.createElement("DIV");
		resizer.id=id;
		resizer.style.position="fixed";
		resizer.style.width=5+"px";
		resizer.className="StressColResizer";
		var anchor=document.createElement("DIV");
		anchor.id="stress-col-resizer-anchor";
		anchor.style.position="relative";
		anchor.style.width=5+"px";
		anchor.style.height=h+"px";
		anchor.className="StressColResizerAnchor";
		resizer.appendChild(anchor);
		bar=document.createElement("DIV");
		bar.id="stress-col-resizer-bar-"+scrolled+"x"+col;
		bar.style.position="relative";
		bar.style.width=1+"px";
		bar.style.left=2+"px";
		bar.style.top=0+"px";
		bar.style.height=h2+"px";
		bar.className="StressColResizerBar";
		bar.style.visibility="hidden";
		resizer.appendChild(bar);
		resizer.dataset.col=col;
		resizer.dataset.scrolled=scrolled;
		control.dom.val.appendChild(resizer);
		resizer.style.left=(x+1)+"px";
		resizer.style.top=(y+1)+"px";/*1 is for the top border*/
		resizer.style.height=h+"px";
		resizer.style.visibility="visible";
		$(resizer).draggable({
			axis:"x",
			containment:$control,
			start:(function(barId){
				return function(event,ui){
					$(event.target).addClass("Dragging");
					$(event.target.children[0]).addClass("StressColResizerAnchorHover");
					document.getElementById(barId).style.visibility="visible";
				};
			})(bar.id),
			stop:(function(barId){
				return function(event,ui){
					var col=ui.helper.context.dataset.col;
					var scrolled=Number(ui.helper.context.dataset.scrolled);
					var source=control.getSlimsheetSource();
					var delta=Math.max(source.widths[scrolled][col]+(ui.position.left-ui.originalPosition.left),5);/*at least 5 pixels wide minimum*/
					source.widths[scrolled][Number(col)]=delta;	//S1348658
					var w = 0;
					_.each(source.widths[scrolled], function (width) {
						if (width) {	// S1348658
							w += width;
						}
					});
					switch(scrolled){
						case 0:
							//source.widths[scrolled][col]=delta+20;
							source.info.fixed.width = w;
							break;
						case 1:
							source.info.scrolled.width=w;
							break;
					}
					// store the new widths
					source.putToLocalStorage();
					$(event.target).removeClass("Dragging");
					$(event.target.children[0]).removeClass("StressColResizerAnchorHover");
					document.getElementById(barId).style.visibility="hidden";
					control.dom.body.data.val.removeChild(control.dom.body.data.headers.val);
					control.dom.body.data.val.removeChild(control.dom.body.data.contents.val);
					sas.stress.wkbench.widget.Slimsheet.renderTable(control,control.getDomRef());
				};
			})(bar.id)
		});
	}
};
//IN-PLACE EDIT
sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit=function(control){
	var id=control.getId()+"-inplace-edit";
	var inplace=document.getElementById(id);
	if (inplace === null){
		var allInPlaces=document.getElementsByClassName("StressSlimsheetInplace");
		inplace=_.find(allInPlaces, function(ourInPlace){
			return ourInPlace.style.visibility === "visible";
		});
	}
	if(inplace&&(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE)){
		inplace.style.visibility="hidden";
	}
};

sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth=function(tester,inplace){
	var $inplace=$(inplace);
	var stringWidth=$(tester).text(inplace.value).width();
	var maxWidth=$(window).width()-$inplace.offset().left-$(window).scrollLeft();
	var rows=$inplace.attr('rows');
	var width=$inplace.width();
	var computedWidth=rows*width;
	while(stringWidth>computedWidth){
		if(width+40<maxWidth){
			$inplace.width(width+40);
		}else{
			$inplace.attr('rows',++rows);
		}
		width=$inplace.width();
		computedWidth=rows*width;
	}
};
sas.stress.wkbench.widget.Slimsheet._calculateSpanOnHScroll=function(currentNode,col,scrolledToColumn){
	if (currentNode===undefined){
		return 1;
	}
	var span=sas.stress.wkbench.model.TreeNode.getSpan(currentNode);
	if (!scrolledToColumn){    // are we scrolling (firstCol!==0 in this case)
		return span;    // no we are not, return the span of the node
	}
	var prevNode=currentNode.getPrevious();
	var previousSpan= 0, previousCol=0;
	while(prevNode){
		previousSpan+=sas.stress.wkbench.model.TreeNode.getSpan(prevNode);
		//span-=previousSpan;
		previousCol+=previousSpan;      // the column after the span
		prevNode=prevNode.getPrevious();
	}

	// the span is the current col - earlier cols (all the earlier cols are due to the spans)
	span=span-(col-previousSpan);

	if (span>0) {
		return span;
	} else{
		return Math.abs(span);
	}
};
sas.stress.wkbench.widget.Slimsheet._calculateSpanOnVScroll=function(currentNode,row,previousRow){
	var span=sas.stress.wkbench.model.TreeNode.getSpan(currentNode);

	var prevNode=currentNode.getPrevious();
	var previousSpan= 0,i=0;
	if(prevNode) {
		if (prevNode.getOrder()) { // not at root
			while (prevNode) {
				span += sas.stress.wkbench.model.TreeNode.getSpan(prevNode);
				prevNode = prevNode.getPrevious();
				if (previousRow > 0 && (i++ === (previousRow - 1))) {
					break;
				}
			}
		} else if (prevNode.getChildren().length > 1) {
			while (prevNode) {
				span += sas.stress.wkbench.model.TreeNode.getSpan(prevNode);
				prevNode = prevNode.getPrevious();
				if (previousRow > 0 && (i++ === (previousRow - 1))) {
					break;
				}
			}
		}
	}

	if (previousRow>0){
		span=row-span;
	}
	if (span>0) {
		return span;
	} if (span===0){
		return 1;
	} else{
		return Math.abs(span);
	}
};

/* CLICK HANDLER */
sas.stress.wkbench.widget.Slimsheet.doClickAction=function(e,control){
	var target=e.target;
	var row=parseInt(target.dataset.row);
	var col=parseInt(target.dataset.col);
	var source=control.getSlimsheetSource();
	sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);
	if(source.isSelectable(row,col)&&target.tagName==="DIV"&&target.id&&target.id.indexOf("-scrolled-")!==-1){
		control.fireCellSelected({selected:true,row:row,col:source.getRealColumn(col),filter:source.getCellFilter(row,col)});
	}
	e.preventDefault();
	e.stopPropagation();
};

/* DOUBLE CLICK HANDLER */
sas.stress.wkbench.widget.Slimsheet.doDblClickAction=function(e,control){
	var rowStr=e.target.dataset.row;
	var colStr=e.target.dataset.col;
	var source=control.getSlimsheetSource();
	if(!isNaN(rowStr) && !isNaN(colStr) && !source.isSelectable(parseInt(rowStr)+control.firstRow,parseInt(colStr)+control.firstCol)){
		return;
	}/*only show in place edit for selectable cells*/
	/*only show in place edit for editable cells*/
	var filter=source.getCellFilter(rowStr,colStr);
	if (!filter.getSheetInfo().getData().isEditable(Number(rowStr),Number(colStr)+1)){
		return;
	}
	var id=control.getId()+"-inplace-edit";
	var inplace=document.getElementById(id);
	var tester=document.getElementById(id+"-tester");
	var y=$(e.target).offset().top-$(window).scrollTop();
	var x=$(e.target).offset().left-$(window).scrollLeft();
	if(!inplace){
		inplace=document.createElement("TEXTAREA");
		inplace.style.resize="none";
		inplace.id=id;
		inplace.className='StressSlimsheetInplace';
		$(inplace).css({'font': $(e.target.parentElement.parentElement).css("font")});
		window.document.body.appendChild(inplace);
		tester=document.createElement("DIV");
		tester.id=id+"-tester";
		$(tester).css({
			'position': 'absolute',
			'float': 'left',
			'white-space': 'nowrap',
			'visibility': 'hidden',
			'font': $(e.target.parentElement.parentElement).css("font")});
		window.document.body.appendChild(tester);
	}
	inplace.rows=1;
	inplace.style.visibility="visible";
	inplace.style.width=$(e.target).width()+7+"px";//border:2+2 padding:1+2
	inplace.style.top=y+"px";
	inplace.style.left=x+"px";
	var formulaField=sas.stress.wkbench.ViewManager.getCellEditor().formulaField;
	inplace.value=formulaField.getLiveValue();
	sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth(tester,inplace);
	$(formulaField.getDomRef()).focus();
	$(inplace).focus();
	sas.stress.wkbench.ViewManager.getCellEditor().getController().gainedFocus();
	$(inplace).keydown(function(event){
		switch(event.keyCode){
			case 27:/*Esc*/
				sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);
				sas.stress.wkbench.ViewManager.getCellEditor().cancelEditButton.firePress({});
				break;
			case 13:/*Enter*/
				sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);
				sas.stress.wkbench.ViewManager.getCellEditor().saveEditButton.firePress({});
				break;
		}
	});
	$(inplace).keyup(function(event){
		switch(event.keyCode){
			case 27:/*Esc*/
			case 13:/*Enter*/
				break;
			default:
				sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth(tester,inplace);
				formulaField.setValue(inplace.value);
				$(formulaField.getDomRef()).keypress();
		}
	});
	$(inplace).blur(function(){
		sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);
		sas.stress.wkbench.ViewManager.getCellEditor().saveEditButton.firePress({});
	});
	//$(inplace).focusout(function(){sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);});
	sas.stress.wkbench.StressUtil.setCaretPosition(id,inplace.value.length);
};

sas.stress.wkbench.widget.Slimsheet._doesNodeHaveSubtotalChild=function(node){
	if (node){
		if (node.getSubtotalLikey()!==undefined&&node.getChildren().length===0){
			return true;
		}
		var subtotalChild=node.getChildren()[0];
		return subtotalChild!==undefined&&undefined!==subtotalChild.getSubtotalLikey();
	}

	return false;
};